<?php if ( !defined( 'ABSPATH' ) ) exit; ?>

<!--

	1 - GENERAL

		1.1 - Font size
		1.2 - Font type
			- Font type
			- Fonts System
			- Fonts Custom

-->

<?php

	// Primary
	$st_['primary'] = esc_html( !empty( $st_Settings['color-primary'] ) ? $st_Settings['color-primary'] : $st_Options['panel']['style']['general']['colors']['primary']['hex'] );

	// Secondary
	$st_['secondary'] = esc_html( !empty( $st_Settings['color-secondary'] ) ? $st_Settings['color-secondary'] : $st_Options['panel']['style']['general']['colors']['secondary']['hex'] );

	// Default fonts
	$st_['font_custom_code_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_code'] ) ? $st_Options['panel']['fonts']['general']['font_custom_code'] : "<link href='http://fonts.googleapis.com/css?family=Open+Sans:300,400,700' rel='stylesheet' type='text/css'>";
	$st_['font_custom_css_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_css'] ) ? $st_Options['panel']['fonts']['general']['font_custom_css'] : "font-family: 'Open Sans', sans-serif;";
	$st_['font_custom_tags_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_tags'] ) ? $st_Options['panel']['fonts']['general']['font_custom_tags'] : "body, div, td";

	$st_['font_custom_code_2_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_code_2'] ) ? $st_Options['panel']['fonts']['general']['font_custom_code_2'] : '';
	$st_['font_custom_css_2_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_css_2'] ) ? $st_Options['panel']['fonts']['general']['font_custom_css_2'] : '';
	$st_['font_custom_tags_2_default'] = !empty( $st_Options['panel']['fonts']['general']['font_custom_tags_2'] ) ? $st_Options['panel']['fonts']['general']['font_custom_tags_2'] : "h1, h2, h3, h4, h5, h6, blockquote";

?>

<style>

	html {
		background: #F9F9F9;
	}

	#panelHeader {
		background: #<?php echo $st_['primary'] ?>;
	}

	#panelSaveButton {
		background-color: #<?php echo $st_['secondary'] ?>;
	}

	.panel-fieldset legend {
		color: #<?php echo $st_['secondary'] ?>;
	}

</style>

<form action="" enctype="multipart/form-data" method="post">

	<input type="hidden" id="st_fonts_settings_action" name="st_fonts_settings_action" value="save">
	<input type="hidden" name="tab_st_fonts_settings" value="<?php echo esc_html( !empty( $st_Settings['tab_st_fonts_settings'] ) ? $st_Settings['tab_st_fonts_settings'] : '' ); ?>" id="input-panelTabsNav" />


	
	<div id="themePanel">



		<div id="panelHeader">
	
			<div id="panelTitle"><?php esc_html_e( 'Fonts Settings', 'stkit' ); echo ' <span>ST Kit v.' . esc_html__( $st_Kit['version'] ); ?></span></div>
	
			<input type="submit" id="panelSaveButton" value="<?php esc_attr_e( 'Save changes', 'stkit' )?>" name="cp_save" />

			<div id="messageUpdated"><?php echo $st_['message']; ?></div>

			<div class="clear"><!-- --></div>
	
			<ul id="panelTabsNav">
				<?php

					// General nav tab
					if ( $st_Options['panel']['fonts']['general']['status'] )
						echo '<li><a href="#general">' . esc_html__( 'General', 'stkit' ) . '</a></li>';

				?>
			</ul>
	
			<div class="clear"><!-- --></div>
	
		</div>


	
		<!--=============================================
		
			G E N E R A L
			A page with fonts settings
		
		==============================================-->

		<?php

			// General tab
			if ( $st_Options['panel']['fonts']['general']['status'] ) {	?>

				<div id="general" class="panelTab">
		
		
					<!-------------------------------------------
						1.1 - Font size
					-------------------------------------------->

					<fieldset class="panel-fieldset"><legend><?php esc_html_e( 'General', 'stkit' ) ?></legend>

						<?php // Font size
							if ( $st_Options['panel']['fonts']['general']['font_size'] ) { ?>

								<dl>
									<dt>
										<span><?php esc_html_e( 'Font size', 'stkit' ) ?></span>
									</dt>
									<dd>
										<input type="text" id="font_size" name="font_size" class="input-short" value="<?php echo esc_html( !empty( $st_Settings['font_size'] ) ? $st_Settings['font_size'] : 14 ); ?>" />
										<div class="slider-box"><div id="font_size-slider"></div></div>
										<div class="clear"><!-- --></div>
										<small><?php esc_html_e( 'Content font size.', 'stkit' ) ?></span></small>
									</dd>
								</dl><?php
	
							}
						?>

					</fieldset>


					<!-------------------------------------------
						1.2 - Font type
					-------------------------------------------->

					<fieldset class="panel-fieldset"><legend><?php esc_html_e( 'Font type', 'stkit' ) ?></legend>


						<!--- Font type ------------------------------>

						<?php // Font type
							if ( $st_Options['panel']['fonts']['general']['font_type'] ) { ?>

								<dl>
									<dt>
										<small>_</small>
									</dt>
									<dd>

										<label id="radio-font-system" class="tooltip" title="<?php esc_html_e( 'System fonts', 'stkit' ) ?>"><input type="radio" value="standard" name="font_type"
										<?php if ( !empty( $st_Settings['font_type'] ) && $st_Settings['font_type'] == 'standard' || !isset( $st_Settings['font_type'] ) ) echo 'checked="checked"'; ?> /><?php esc_html_e( 'Standard', 'stkit' ) ?></label>

										<label id="radio-font-custom" class="tooltip" title="<?php esc_html_e( 'Google fonts', 'stkit' ) ?>"><input type="radio" value="custom" name="font_type"
										<?php if ( !empty( $st_Settings['font_type'] ) && $st_Settings['font_type'] == 'custom' ) echo 'checked="checked"'; ?> /><?php esc_html_e( 'Custom', 'stkit' ) ?></label>

									</dd>
								</dl><?php
	
							}
						?>


						<!--- Fonts System ------------------------------>

						<div id="font-system">

							<dl>
								<dt>
									<small>_</small>
								</dt>
								<dd>

									<select name="font_system">
										<?php
		
											foreach ( $st_Kit['fonts_system'] as $key ) {
		
												$out = "\n" . '<option value="' . $key . '"';
		
												if ( !empty( $st_Settings['font_system'] ) && $st_Settings['font_system'] == $key )
													$out .= ' selected ';
		
												$out .= '>' . $key . '</option>';
		
												echo $out;
		
											};
										?>
									</select>
									<small><?php esc_html_e( 'Select a font family.', 'stkit' ) ?></span></small>

								</dd>
							</dl>

						</div>


						<!--- Fonts Custom ------------------------------>

						<?php // Fonts Custom
							if ( $st_Options['panel']['fonts']['general']['font_custom'] ) { ?>

								<div id="font-custom">


									<!--- Before starting --->

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<?php

												echo wp_kses( __( 'Choose the font you want from Google <a href="http://google.com/fonts">library</a> and press', 'stkit' ), $st_Kit['tags_allowed'] )

											?>&nbsp;<img src="<?php echo plugins_url() ?>/stkit/assets/images/quick_use_static.png" class="tooltip" title="Quick-use" alt=""/>
										</dd>
									</dl>


									<!--- Step 1 --->

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<?php esc_html_e( 'Choose the styles you want.', 'stkit' ) ?>
										</dd>
									</dl>


									<!--- Step 2 --->

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<?php esc_html_e( 'Choose the character sets you want.', 'stkit' ) ?>
										</dd>
									</dl>


									<!--- Primary font --->

									<dl>
										<dt>
											<span><?php esc_html_e( 'Primary font', 'stkit' ) ?></span>
										</dt>
										<dd>
											<input type="text" name="font_custom_code" value="<?php echo esc_attr( !empty( $st_Settings['font_custom_code'] ) ? $st_Settings['font_custom_code'] : $st_['font_custom_code_default'] ); ?>" />
											<small><?php esc_html_e( 'Add code.', 'stkit' ) ?></small>
										</dd>
									</dl>

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<input type="text" name="font_custom_css" value="<?php echo esc_attr( !empty( $st_Settings['font_custom_css'] ) ? $st_Settings['font_custom_css'] : $st_['font_custom_css_default'] ); ?>" />
											<small><?php esc_html_e( 'Set font family.', 'stkit' ) ?></small>
										</dd>
									</dl>

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<textarea name="font_custom_tags" /><?php echo esc_attr( !empty( $st_Settings['font_custom_tags'] ) ? $st_Settings['font_custom_tags'] : $st_['font_custom_tags_default'] ); ?></textarea>
											<small><?php esc_html_e( 'Select a tags and CSS-classes which will be linked with the font.', 'stkit' ) ?></small>
										</dd>
									</dl>

									<!--- Secondary font --->

									<dl>
										<dt>
											<span><?php esc_html_e( 'Secondary font', 'stkit' ) ?></span>
										</dt>
										<dd>
											<input type="text" name="font_custom_code_2" value="<?php echo esc_attr( !empty( $st_Settings['font_custom_code_2'] ) ? $st_Settings['font_custom_code_2'] : $st_['font_custom_code_2_default'] ); ?>" />
											<small><?php esc_html_e( 'Add code.', 'stkit' ) ?></small>
										</dd>
									</dl>

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<input type="text" name="font_custom_css_2" value="<?php echo esc_attr( !empty( $st_Settings['font_custom_css_2'] ) ? $st_Settings['font_custom_css_2'] : $st_['font_custom_css_2_default'] ); ?>" />
											<small><?php esc_html_e( 'Set font family.', 'stkit' ) ?></small>
										</dd>
									</dl>

									<dl>
										<dt>
											<small>_</small>
										</dt>
										<dd>
											<textarea name="font_custom_tags_2" /><?php echo esc_attr( !empty( $st_Settings['font_custom_tags_2'] ) ? $st_Settings['font_custom_tags_2'] : $st_['font_custom_tags_2_default'] ); ?></textarea>
											<small><?php esc_html_e( 'Select a tags and CSS-classes which will be linked with the font.', 'stkit' ) ?></small>
										</dd>
									</dl>


								</div><?php
	
							}
						?>


					</fieldset>
		
				</div><!-- #general --><?php

			}

		?>



	</div><!-- #themePanel -->



</form>