<?php if ( !defined( 'ABSPATH' ) ) exit; ?>

<!--

	1 - GENERAL

		1.1 - Layout

	2 - HEADER

		n/a

	3 - FOOTER

		3.1 - Footer

	4 - SOCIAL

		4.1 - Social

-->

<?php

	// Primary
	$st_['primary'] = esc_html( !empty( $st_Settings['color-primary'] ) ? $st_Settings['color-primary'] : $st_Options['panel']['style']['general']['colors']['primary']['hex'] );

	// Secondary
	$st_['secondary'] = esc_html( !empty( $st_Settings['color-secondary'] ) ? $st_Settings['color-secondary'] : $st_Options['panel']['style']['general']['colors']['secondary']['hex'] );

?>

<style>

	html {
		background: #F9F9F9;
	}

	#panelHeader {
		background: #<?php echo $st_['primary'] ?>;
	}

	#panelSaveButton {
		background-color: #<?php echo $st_['secondary'] ?>;
	}

	.panel-fieldset legend {
		color: #<?php echo $st_['secondary'] ?>;
	}

</style>

<form action="" enctype="multipart/form-data" method="post">

	<input type="hidden" id="st_layout_settings_action" name="st_layout_settings_action" value="save">
	<input type="hidden" name="tab_st_layout_settings" value="<?php echo esc_html( !empty( $st_Settings['tab_st_layout_settings'] ) ? $st_Settings['tab_st_layout_settings'] : '' ); ?>" id="input-panelTabsNav" />


	
	<div id="themePanel">



		<div id="panelHeader">
	
			<div id="panelTitle"><?php esc_attr_e( 'Layout Settings', 'stkit' ); echo ' <span>ST Kit v.' . esc_html__( $st_Kit['version'] ); ?></span></div>
	
			<input type="submit" id="panelSaveButton" value="<?php esc_attr_e( 'Save changes', 'stkit' )?>" name="cp_save" />

			<div id="messageUpdated"><?php echo $st_['message']; ?></div>

			<div class="clear"><!-- --></div>
	
			<ul id="panelTabsNav">
				<?php

					// General nav tab
					if ( $st_Options['panel']['layout']['general']['status'] )
						echo '<li><a href="#general">' . esc_attr__( 'General', 'stkit' ) . '</a></li>';

					// Header nav tab
					echo '<li><a href="#st_header">' . esc_attr__( 'Header', 'stkit' ) . '</a></li>'; // #st_header

					// Footer nav tab
					if ( $st_Options['panel']['layout']['footer']['status'] )
						echo '<li><a href="#st_footer">' . esc_attr__( 'Footer', 'stkit' ) . '</a></li>'; // #st_footer

					// Sidebar nav tab
					if ( $st_Options['panel']['major']['sidebar']['status'] )
						echo '<li><a href="#sidebar">' . esc_attr__( 'Sidebar', 'stkit' ) . '</a></li>';


				?>
			</ul>
	
			<div class="clear"><!-- --></div>
	
		</div>


	
		<!--=============================================
		
			G E N E R A L
			A page with general settings
		
		==============================================-->

		<?php

			// General tab
			if ( $st_Options['panel']['layout']['general']['status'] ) {	?>

				<div id="general" class="panelTab">
		
		
					<!-------------------------------------------
						1.1 - Layout
					-------------------------------------------->

					<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Layout', 'stkit' ) ?></legend>

						<?php // Layout
							if ( $st_Options['panel']['layout']['general']['layout_type'] ) { ?>
	
								<dl>
									<dt>
										<?php esc_attr_e( 'Type', 'stkit' ) ?>
									</dt>
									<dd>
				
										<label><input type="radio" value="responsive" name="layout_type"
										<?php if ( !empty( $st_Settings['layout_type'] ) && $st_Settings['layout_type'] == 'responsive' || !isset( $st_Settings['layout_type'] ) ) echo 'checked="checked"'; ?> /> <?php esc_attr_e( 'Responsive', 'stkit' ) ?></label>
	
										<label><input type="radio" value="standard" name="layout_type"
										<?php if ( !empty( $st_Settings['layout_type'] ) && $st_Settings['layout_type'] == 'standard' ) echo 'checked="checked"'; ?> /> <?php esc_attr_e( 'Classic', 'stkit' ) ?></label>
				
									</dd>
								</dl><?php
	
							}
						?>

						<?php // Design
							if ( !empty( $st_Options['panel']['layout']['general']['layout_design'] ) ) { ?>
	
								<dl>
									<dt>
										<?php esc_attr_e( 'Design', 'stkit' ) ?>
									</dt>
									<dd>
				
										<label><input type="radio" value="wide" name="layout_design"
										<?php if ( !empty( $st_Settings['layout_design'] ) && $st_Settings['layout_design'] == 'wide' || !isset( $st_Settings['layout_design'] ) ) echo 'checked="checked"'; ?> /> <?php esc_attr_e( 'Wide', 'stkit' ) ?></label>
	
										<label><input type="radio" value="boxed" name="layout_design"
										<?php if ( !empty( $st_Settings['layout_design'] ) && $st_Settings['layout_design'] == 'boxed' ) echo 'checked="checked"'; ?> /> <?php esc_attr_e( 'Boxed', 'stkit' ) ?></label>
				
									</dd>
								</dl><?php
	
							}
						?>

					</fieldset>

		
				</div><!-- #general --><?php

			}

		?>



		<!--=============================================
		
			H E A D E R
			A page with header settings
		
		==============================================-->

		<div id="st_header" class="panelTab">


			<!-------------------------------------------
				3.1 - Header
			-------------------------------------------->

			<?php // Header
				if ( !empty( $st_Options['panel']['layout']['header']['scheme']['status'] ) == true ) { ?>

					<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Header', 'stkit' ) ?></legend>
		
						<dl>
							<dt>
								<span><?php esc_attr_e( 'Scheme', 'stkit' ) ?></span>
							</dt>
							<dd>

								<?php

									$st_['array'] = $st_Options['panel']['layout']['header']['templates'];

									foreach ( $st_['array'] as $key ) {

										$st_['checked'] = '';

										// Select the First in case database is empty
										if ( !isset( $st_Settings['header_template'] ) && $key == $st_Options['panel']['layout']['header']['scheme']['default'] )
											$st_['checked'] = 'checked="checked"';

										// Select requred scheme
										if ( !empty( $st_Settings['header_template'] ) && $st_Settings['header_template'] == $key )
											$st_['checked'] = 'checked="checked"'; ?>

										<div class="tmpl_radio">
											<label class="lable-img" for="header_template_<?php echo $key ?>">
												<img src="<?php echo plugins_url() ?>/stkit/assets/images/schemes/template_header/<?php echo $key ?>.png" width="70" height="50">
											</label>
											<input type="radio" name="header_template" value="<?php echo $key ?>" id="header_template_<?php echo $key ?>" <?php echo $st_['checked'] ?> />
										</div><?php

									}

								?>
								<small><?php esc_attr_e(' Select a scheme.', 'stkit' ) ?></small>

							</dd>
						</dl>

					</fieldset><?php

				}


			// Social tab
			if ( $st_Options['panel']['layout']['social']['status'] ) {	?>


				<!-------------------------------------------
					4.2 - Social icons
				-------------------------------------------->

				<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Social icons', 'stkit' ) ?></legend><?php

					if ( !isset($st_Options['panel']['layout']['social']['icons']) || $st_Options['panel']['layout']['social']['icons'] != false ) { ?>

						<dl>
							<dt>
								<?php esc_attr_e( 'Icons', 'stkit' ) ?>
							</dt>
							<dd>
								<label>
									<input type="checkbox" name="lifestream" value="yes" <?php if ( !empty( $st_Settings['lifestream'] ) && $st_Settings['lifestream'] == 'yes' ) echo 'checked'; ?> /> 
									<?php esc_attr_e( 'Display', 'stkit' ) ?>
								</label>
								<small><?php esc_attr_e( 'Display social icons.', 'stkit' ) ?></small>
							</dd>
						</dl><?php

					} ?>

					<dl>
						<dt>
							<span><?php esc_attr_e( 'URLs', 'stkit' ) ?></span>
						</dt>
						<dd>
							<?php
								foreach ( $st_Options['networks'] as $key ) {

									$st_['icon'] = substr( $key, 5 );

									$st_['value'] = !empty( $st_Settings[$key] ) ? $st_Settings[$key] : '';

									echo "\n" . '<input type="text" class="input-social-icon tooltip" title="' . esc_attr( $st_['icon'] ) . '" name="' . esc_attr( $key ) . '" value="' . esc_attr( $st_['value'] ) . '" class="input ' . esc_attr( $key ) . '" size="" style="background-image: url(' . plugins_url() . '/stkit/assets/images/icons/18/social/color/' . esc_attr( $st_['icon'] ) . '.png);" /> ';

								}
							?>
							<small><?php esc_attr_e( 'Enter URL paths to your network profiles.', 'stkit' ) ?></small>
						</dd>
					</dl>

					<dl>
						<dt>
							<span><?php esc_attr_e( 'Custom Icons', 'stkit' ) ?></span>
						</dt>
						<dd>
							<textarea name="lifestream_custom" /><?php echo !empty( $st_Settings['lifestream_custom'] ) ? esc_textarea( $st_Settings['lifestream_custom'] ) : ''; ?></textarea>
							<small>
								<?php esc_attr_e( 'You also can set a custom icons, counters etc. Shortcodes allowed.', 'stkit' ) ?><br/>
								<?php esc_attr_e( 'Draft', 'stkit' ) ?>: <code>&lt;a rel="nofollow" class="icon-custom" target="_blank" href="#">&lt;img src="ICON-PATH.PNG" title="Hello World!" class="tooltip" alt="" />&lt;/a></code>
							</small>
						</dd>
					</dl>

				</fieldset><?php


			} ?>


		</div><!-- #header -->



		<!--=============================================
		
			F O O T E R
			A page with footer settings
		
		==============================================-->

		<?php

			// Footer tab
			if ( $st_Options['panel']['layout']['footer']['status'] ) {	?>

				<div id="st_footer" class="panelTab">
		
		
					<!-------------------------------------------
						3.1 - Footer
					-------------------------------------------->

					<?php // Footer
						if ( $st_Options['panel']['layout']['footer']['scheme']['status'] ) { ?>

							<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Footer', 'stkit' ) ?></legend>
				
								<dl>
									<dt>
										<span><?php esc_attr_e( 'Scheme', 'stkit' ) ?></span>
									</dt>
									<dd>

										<?php

											$st_['array'] = array('1','2','3','4','5','6','none');

											foreach ( $st_['array'] as $key ) {

												$st_['checked'] = '';

												// Select the First in case database is empty
												if ( !isset( $st_Settings['footer_sidebars'] ) && $key == $st_Options['panel']['layout']['footer']['scheme']['default'] )
													$st_['checked'] = 'checked="checked"';

												// Select requred scheme
												if ( !empty( $st_Settings['footer_sidebars'] ) && $st_Settings['footer_sidebars'] == $key )
													$st_['checked'] = 'checked="checked"'; ?>

												<div class="tmpl_radio">
													<label class="lable-img" for="footer_sidebars_<?php echo $key ?>">
														<img src="<?php echo plugins_url() ?>/stkit/assets/images/schemes/sidebar_footer/<?php echo $key ?>.png" width="50" height="40">
													</label>
													<input type="radio" name="footer_sidebars" value="<?php echo $key ?>" id="footer_sidebars_<?php echo $key ?>" <?php echo $st_['checked'] ?> />
												</div><?php

											}

										?>
										<small><?php esc_attr_e(' Select a scheme of footer sidebars.', 'stkit' ) ?></small>

									</dd>
								</dl>

							</fieldset><?php

						}
					?>

		
				</div><!-- #footer --><?php

			}

		?>



		<!--=============================================
		
			S I D E B A R
			Sidebar settings
		
		==============================================-->

		<?php

			// Sidebar tab
			if ( $st_Options['panel']['major']['sidebar']['status'] ) {	?>

				<div id="sidebar" class="panelTab">
			
		
					<!-------------------------------------------
						5.1 - Additional sidebars
					-------------------------------------------->

					<?php // Additional sidebars
						if ( $st_Options['panel']['major']['sidebar']['additional'] ) { ?>	

							<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Additional Sidebars', 'stkit' ) ?></legend>

								<dl>
									<dt>
										<span><?php esc_attr_e( 'Quantity', 'stkit' ) ?></span>
									</dt>
									<dd>
										<input type="text" id="sidebar_qty" name="sidebar_qty" class="input-short" value="<?php echo esc_html( !empty( $st_Settings['sidebar_qty'] ) ? $st_Settings['sidebar_qty'] : 0 ); ?>" />
										<div class="slider-box"><div id="sidebar_qty-slider"></div></div>
										<div class="clear"><!-- --></div>
										<small><?php esc_attr_e( 'If you need more sidebars besides standard, please, set a number you want, but at least 2.', 'stkit' ) ?></small>
									</dd>
								</dl>

							</fieldset><?php

						}
					?>
			
		
					<!-------------------------------------------
						5.2 - Labels
					-------------------------------------------->

					<?php // Labels
						if ( !empty( $st_Options['panel']['major']['sidebar']['labels'] ) && !empty( $st_Settings['sidebar_qty'] ) ) { ?>	

							<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Labels', 'stkit' ) ?></legend>

								<dl>
									<dt>
										<small>_</small>
									</dt>
									<dd>
										<?php
											for ( $st_['x'] = 0; $st_['x'] <= $st_Settings['sidebar_qty'] - 1; $st_['x']++ ) { ?>
												<input type="text" name="sidebar_labels[]" value="<?php echo esc_attr( !empty( $st_Settings['sidebar_labels'][$st_['x']] ) ? $st_Settings['sidebar_labels'][$st_['x']] : 'Custom bar ' . $st_['x'] ); ?>" /><?php
											}
										?>
									</dd>
								</dl>

							</fieldset><?php

						}
					?>


					<!-------------------------------------------
						5.3 - Sidebar position
					-------------------------------------------->

					<?php // Sidebar position
						if ( !empty( $st_Options['panel']['major']['sidebar']['position']['status'] ) ) { ?>

							<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Sidebar position', 'stkit' ) ?></legend>
				
								<dl>
									<dt>
										<span><?php esc_attr_e( 'Default', 'stkit' ) ?></span>
									</dt>
									<dd>

										<?php

											$st_['array'] = array('left','none','right');

											foreach ( $st_['array'] as $key ) {

												$st_['checked'] = '';

												// Select the First in case database is empty
												if ( !isset( $st_Settings['sidebar_position'] ) && $key == $st_Options['panel']['major']['sidebar']['position']['default'] )
													$st_['checked'] = 'checked="checked"';

												// Select requred scheme
												if ( !empty( $st_Settings['sidebar_position'] ) && $st_Settings['sidebar_position'] == $key )
													$st_['checked'] = 'checked="checked"'; ?>

												<div class="tmpl_radio">
													<label class="lable-img" for="sidebar_position_<?php echo $key ?>">
														<img src="<?php echo plugins_url() ?>/stkit/components/metaboxes/assets/images/schemes/<?php echo $key ?>.png" width="50" height="40">
													</label>
													<input type="radio" name="sidebar_position" value="<?php echo $key ?>" id="sidebar_position_<?php echo $key ?>" <?php echo $st_['checked'] ?> />
												</div><?php

											}

										?>
										<small><?php esc_attr_e(' Select the default position of sidebar.', 'stkit' ) ?></small>

									</dd>
								</dl>

							</fieldset><?php

						}
					?>


					<!-------------------------------------------
						5.4 - Options
					-------------------------------------------->

					<?php // Options
						if ( !empty( $st_Options['panel']['major']['sidebar']['options'] ) ) { ?>	

							<fieldset class="panel-fieldset"><legend><?php esc_attr_e( 'Options', 'stkit' ) ?></legend>

								<dl>
									<dt>
										<?php esc_attr_e( 'Primary sidebar', 'stkit' ) ?>
									</dt>
									<dd>
										<label>
											<input type="checkbox" name="sidebar_primary_sticky" value="yes" <?php if ( !empty( $st_Settings['sidebar_primary_sticky'] ) && $st_Settings['sidebar_primary_sticky'] == 'yes' ) echo 'checked'; ?> />
											<?php esc_attr_e( 'Sticky', 'stkit' ) ?>
										</label>
										<small><?php esc_attr_e( 'These settings will be used by default.', 'stkit' ) ?></small>
									</dd>
								</dl>

								<?php
									if ( !empty( $st_Options['sidebars']['post-sidebar'] ) ) { ?>	

										<dl>
											<dt>
												<?php esc_attr_e( 'Post sidebar', 'stkit' ) ?>
											</dt>
											<dd>
												<label>
													<input type="checkbox" name="sidebar_post_sticky" value="yes" <?php if ( !empty( $st_Settings['sidebar_post_sticky'] ) && $st_Settings['sidebar_post_sticky'] == 'yes' ) echo 'checked'; ?> />
													<?php esc_attr_e( 'Sticky', 'stkit' ) ?>
												</label>
												<small><?php esc_attr_e( 'These settings will be used by default.', 'stkit' ) ?></small>
											</dd>
										</dl><?php

									}
								?>
							</fieldset><?php

						}
					?>


				</div><!-- #page --><?php

			}

		?>



		<!--=============================================
		
			S O C I A L
			A social icons on header or footer
		
		==============================================-->

		<?php

			// Social tab
			if ( $st_Options['panel']['layout']['social']['status'] ) {	?>

				<div id="social" class="panelTab">




				</div><!-- #general --><?php

			}

		?>



	</div><!-- #themePanel -->



</form>