<?php

class st_megamenu_custom_menu {

	function __construct() {

		add_filter( 'wp_setup_nav_menu_item', array( $this, 'st_megamenu_add_custom_nav_fields' ) );
		add_action( 'wp_update_nav_menu_item', array( $this, 'st_megamenu_update_custom_nav_fields'), 10, 3 );
		add_filter( 'wp_edit_nav_menu_walker', array( $this, 'st_megamenu_edit_walker'), 10, 2 );

	}
	
	function st_megamenu_add_custom_nav_fields( $menu_item ) {
	
		$menu_item->sidebar = get_post_meta( $menu_item->ID, '_menu_item_sidebar', true );
		$menu_item->sidebar_columns = get_post_meta( $menu_item->ID, '_menu_item_sidebar_columns', true );
		return $menu_item;
	    
	}
	
	function st_megamenu_update_custom_nav_fields( $menu_id, $menu_item_db_id, $args ) {

	    // Check if element is properly sent
	   if ( isset( $_REQUEST['menu-item-sidebar'] ) && is_array( $_REQUEST['menu-item-sidebar'] ) ) {

			if ( !empty( $_REQUEST['menu-item-sidebar'][$menu_item_db_id] ) ) {
				$sidebar_value = $_REQUEST['menu-item-sidebar'][$menu_item_db_id];
				update_post_meta( $menu_item_db_id, '_menu_item_sidebar', $sidebar_value );
			}

			if ( !empty( $_REQUEST['menu-item-sidebar-columns'][$menu_item_db_id] ) ) {
				$sidebar_columns_value = $_REQUEST['menu-item-sidebar-columns'][$menu_item_db_id];
				update_post_meta( $menu_item_db_id, '_menu_item_sidebar_columns', $sidebar_columns_value );
			}

	    }
	    
	}
	
	function st_megamenu_edit_walker( $walker, $menu_id ) {
	
	    return 'Walker_Nav_Menu_Edit_Custom';
	    
	}

}

// instantiate plugin's class
$GLOBALS['megamenu_custom_menu'] = new st_megamenu_custom_menu();

include_once( 'edit_custom_walker.php' );
//include_once( 'custom_walker.php' );