<?php if ( !defined( 'ABSPATH' ) ) exit;

/*

	1 - METABOX: FORMAT OPTIONS

		1.1 - Array
		1.2 - Controls
		1.3 - Register metabox
		1.4 - Save data

*/

/*===============================================

 	M E T A B O X :   P O S T   O P T I O N S
	An unique settings for each post

===============================================*/


	/*-------------------------------------------
		1.1 - Array
	-------------------------------------------*/

	function st_MetaboxFormat() {

		global
			$st_MetaboxFormat;

			$st_MetaboxFormat = 
		
				array(

					'disable_breadcrumbs' => array(
						'name'			=> 'disable_breadcrumbs',
						'title'			=> esc_attr__( 'Breadcrumbs', 'stkit' ),
						'description'	=> esc_attr__( 'Do not show breadcrumbs.', 'stkit' ),
					),

					'disable_title' => array(
						'name'			=> 'disable_title',
						'title'			=> esc_attr__( 'Title', 'stkit' ),
						'description'	=> esc_attr__( 'Do not show post title.', 'stkit' ),
					),
	
					'subtitle' => array(
						'name'			=> 'subtitle',
						'title'			=> esc_attr__( 'Sub title', 'stkit' ),
						'description'	=> esc_attr__( 'Secondary title of entry.', 'stkit' )
					),
	
					'lightbox' => array(
						'name'			=> 'lightbox',
						'title'			=> esc_attr__( 'Zoom', 'stkit' ),
						'description'	=> esc_attr__( 'Open a full sized featured image in modal window by clicking on thumbnail.', 'stkit' )
					),
	
					'link' => array(
						'name'			=> 'link',
						'title'			=> esc_attr__( 'Link', 'stkit' ),
						'description'	=> esc_attr__( 'Put an URL path.', 'stkit' ),
						'tooltip'		=> esc_attr__( 'e.g. http://google.com', 'stkit' )
					),
	
					'link_title' => array(
						'name'			=> 'link_title',
						'title'			=> esc_attr__( 'Label', 'stkit' ),
						'description'	=> esc_attr__( 'Insert a text of link.', 'stkit' ),
						'tooltip'		=> esc_attr__( 'e.g. Google', 'stkit' )
					),

					'link_redirect' => array(
						'name'			=> 'link_redirect',
						'title'			=> esc_attr__( 'Redirect', 'stkit' ),
						'description'	=> esc_attr__( 'Open the link through redirect.', 'stkit' )
					),

					'quote' => array(
						'name'			=> 'quote',
						'title'			=> esc_attr__( 'Quote', 'stkit' ),
						'description'	=> esc_attr__( 'Insert a quote.', 'stkit' )
					),
	
					'status' => array(
						'name'			=> 'status',
						'title'			=> esc_attr__( 'Status', 'stkit' ),
						'description'	=> esc_attr__( 'Share a status.', 'stkit' )
					),
	
					'mp4' => array(
						'name'			=> 'mp4',
						'title'			=> esc_attr__( 'Self hosted video', 'stkit' ),
						'description'	=> '.mp4',
						'tooltip'		=> esc_attr__( 'e.g. http://site.com/file', 'stkit' )
					),
	
					'ogv' => array(
						'name'			=> 'ogv',
						'title'			=> '',
						'description'	=> '.ogv',
						'tooltip'		=> esc_attr__( 'e.g. http://site.com/file', 'stkit' )
					),
	
					'webm' => array(
						'name'			=> 'webm',
						'title'			=> '',
						'description'	=> '.webm',
						'tooltip'		=> esc_attr__( 'e.g. http://site.com/file', 'stkit' )
					),
	
					'video' => array(
						'name'			=> 'video',
						'title'			=> esc_attr__( 'Embedded video', 'stkit' ),
						'description'	=> esc_attr__( 'If you are not using self hosted video then you can include embedded code here.', 'stkit' )
					),
	
					'mp3' => array(
						'name'			=> 'mp3',
						'title'			=> esc_attr__( 'Self hosted audio', 'stkit' ),
						'description'	=> '.mp3',
						'tooltip'		=> esc_attr__( 'e.g. http://site.com/file', 'stkit' )
					),
	
					'ogg' => array(
						'name'			=> 'ogg',
						'title'			=> '',
						'description'	=> '.ogg',
						'tooltip'		=> esc_attr__( 'e.g. http://site.com/file', 'stkit' )
					),
	
					'audio' => array(
						'name'			=> 'audio',
						'title'			=> esc_attr__( 'Embedded audio', 'stkit' ),
						'description'	=> esc_attr__( 'If you are not using self hosted audio then you can include embedded code here.', 'stkit' )
					),
	
					'gallery' => array(
						'name'			=> 'gallery',
						'title'			=> esc_attr__( 'Gallery', 'stkit' ),
						'description'	=> '',
					),

				);

	}

	add_action( 'admin_init', 'st_MetaboxFormat' );


	/*-------------------------------------------
		1.2 - Controls
	-------------------------------------------*/

		function st_metabox_format() {

			global
				$post,
				$st_Options,
				$st_MetaboxFormat;

				echo '<div id="st_post_format" class="none">' . ( get_post_format( $post->ID ) ? get_post_format( $post->ID ) : 'standard' ) . '</div>';

			foreach ( $st_MetaboxFormat as $section ) {

				// Nonce for verification 
				echo '<input type="hidden" name="' . $section['name'] . '_nonce" value="' . wp_create_nonce( basename(__FILE__) ) . '" />';
	
				echo' <input type="hidden" name="' . $section['name'] . '_noncename" id="' . $section['name'] . '_noncename" value="' . wp_create_nonce( basename(__FILE__) ) . '" />';

				$section_value = get_post_meta( $post->ID, $section['name'] . '_value', true );


				/*--- Disable breadcrumbs -----------------------------*/

				if ( $st_Options['breadcrumbs'] && $section['name'] == 'disable_breadcrumbs' ) { ?>

					<fieldset class="panel-fieldset metabox-fieldset"><legend><?php esc_attr_e( 'Breadcrumbs', 'stkit' ); ?></legend>

						<dl>
							<dt><?php echo $section['title']; ?></dt>
							<dd>
								<label><input type="checkbox" name="<?php echo $section['name']; ?>_value" value="1" <?php if ( $section_value == 1 ) echo 'checked'; ?> /> <?php esc_attr_e( 'Hide', 'stkit' ) ?></label>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Disable title -----------------------------*/

				if ( $section['name'] == 'disable_title' ) { ?>

					<fieldset class="panel-fieldset metabox-fieldset"><legend><?php esc_attr_e( 'Title', 'stkit' ); ?></legend>

						<dl id="fop_disable_title" class="fop_toggle none<?php echo !empty( $st_Options['global']['post-formats']['post-title'] ) ? ' meta-for-all-formats' : ''; ?>">
							<dt><br /><?php echo $section['title']; ?></dt>
							<dd><br />
								<label><input type="checkbox" name="<?php echo $section['name']; ?>_value" value="1" <?php if ( $section_value == 1 ) echo 'checked'; ?> /> <?php esc_attr_e( 'Hide', 'stkit' ) ?></label>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Subtitle -----------------------------*/

				if ( $section['name'] == 'subtitle' ) { ?>

					<fieldset id="fop_subtitle" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt><span class="st_input_title"><?php echo $section['title']; ?></span></dt>
							<dd>
								<div class="st_input_title"><input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" /></div>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Lightbox -----------------------------*/

				if ( $section['name'] == 'lightbox' && $st_Options['global']['post-formats']['image']['status'] ) { ?>

					<fieldset id="fop_lightbox" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php esc_attr_e( 'Image', 'stkit' ); ?></legend>

						<dl>
							<dt><?php echo $section['title']; ?></dt>
							<dd>
								<label><input type="checkbox" name="<?php echo $section['name']; ?>_value" value="1" <?php if ( $section_value == 1 ) echo 'checked'; ?> /> <?php esc_attr_e( 'Enable', 'stkit' ) ?></label>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>
							
					</fieldset><?php

				}


				/*--- Link -----------------------------*/

				if ( $section['name'] == 'link' && $st_Options['global']['post-formats']['link']['status'] ) { ?>

					<fieldset id="fop_link" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt><span><?php echo $section['title']; ?></span></dt>
							<dd>
								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip']; ?>" />
								<small><?php echo $section['description']; ?></small><br />
							</dd>
						</dl>

					<?php

				}

				if ( $section['name'] == 'link_title' && $st_Options['global']['post-formats']['link']['status'] ) { ?>

						<dl>
							<dt><span class="st_input_title"><?php echo $section['title']; ?></span></dt>
							<dd>
								<div class="st_input_title"><input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip']; ?>" /></div>
								<small><?php echo $section['description']; ?></small><br />
							</dd>
						</dl>

					<?php

				}

				/*--- Link redirect -----------------------------*/

				if ( $section['name'] == 'link_redirect' ) {

					if ( $st_Options['panel']['misc']['redirect'] ) { ?>

						<dl>
							<dt><?php echo $section['title']; ?></dt>
							<dd>
								<label><input type="checkbox" name="<?php echo $section['name']; ?>_value" value="1" <?php if ( $section_value == 1 ) echo 'checked'; ?> /> <?php esc_attr_e( 'Enable', 'stkit' ) ?></label>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl><?php
					} ?>

					</fieldset><?php

				}


				/*--- Quote -----------------------------*/

				if ( $section['name'] == 'quote' && $st_Options['global']['post-formats']['quote']['status'] ) { ?>

					<fieldset id="fop_quote" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt><span><?php echo $section['title']; ?></span></dt>
							<dd>
								<textarea name="<?php echo $section['name']; ?>_value" /><?php echo $section_value; ?></textarea>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Status -----------------------------*/

				if ( $section['name'] == 'status' && $st_Options['global']['post-formats']['status']['status'] ) { ?>

					<fieldset id="fop_status" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt><span><?php echo $section['title']; ?></span></dt>
							<dd>
								<textarea name="<?php echo $section['name']; ?>_value" /><?php echo $section_value; ?></textarea>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Video -----------------------------*/

				if ( $section['name'] == 'mp4' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

					<fieldset id="fop_video_selfhosted" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt>
								<div>
									<span><?php esc_attr_e( 'Note:', 'stkit' ) ?></span>
									<small><?php esc_attr_e( 'You must supply an MP4 file to satisfy both HTML5 and Flash solutions. The optional OGV format is used to increase x-browser support for HTML5 browsers such as Firefox and Opera.', 'stkit' ) ?></small>
								</div>
							</dt>
							<dd>
								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip'] . $section['description']; ?>" />
								<small><?php echo $section['description']; ?></small><br />

					<?php

				}

				if ( $section['name'] == 'ogv' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip'] . $section['description']; ?>" />
								<small><?php echo $section['description']; ?></small><br />

					<?php

				}

				if ( $section['name'] == 'webm' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip'] . $section['description']; ?>" />
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}

				if ( $section['name'] == 'video' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

					<fieldset id="fop_video_embedded" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt>
								<div>
									<span><?php esc_attr_e( 'Note:', 'stkit' ) ?></span>
									<small><?php esc_attr_e( 'This field will override the above.', 'stkit' ) ?> <?php esc_attr_e( 'YouTube and Vimeo preferred.', 'stkit' ) ?></small>
								</div>
							</dt>
							<dd>
								<textarea name="<?php echo $section['name']; ?>_value" /><?php echo $section_value; ?></textarea>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Audio -----------------------------*/

				if ( $section['name'] == 'mp3' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

					<fieldset id="fop_audio_selfhosted" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt>
								<div>
									<span><?php esc_attr_e( 'Note:', 'stkit' ) ?></span>
									<small><?php esc_attr_e( 'You must supply both MP3 and OGG files to satisfy all browsers.', 'stkit' ) ?></small>
								</div>
							</dt>
							<dd>
								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip'] . $section['description']; ?>" />
								<small><?php echo $section['description']; ?></small><br />



					<?php

				}

				if ( $section['name'] == 'ogg' && $st_Options['global']['post-formats']['video']['status'] ) { ?>

								<input type="text" name="<?php echo $section['name']; ?>_value" value="<?php echo $section_value; ?>" class="tooltip" title="<?php echo $section['tooltip'] . $section['description']; ?>" />
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}

				if ( $section['name'] == 'audio' && $st_Options['global']['post-formats']['audio']['status'] ) { ?>

					<fieldset id="fop_audio_embedded" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt>
								<div>
									<span><?php esc_attr_e( 'Note:', 'stkit' ) ?></span>
									<small><?php esc_attr_e( 'This field will override the above.', 'stkit' ) ?></small>
								</div>
							</dt>
							<dd>
								<textarea name="<?php echo $section['name']; ?>_value" /><?php echo $section_value; ?></textarea>
								<small><?php echo $section['description']; ?></small>
							</dd>
						</dl>

					</fieldset><?php

				}


				/*--- Gallery -----------------------------*/

				if ( $section['name'] == 'gallery' && $st_Options['global']['post-formats']['gallery']['status'] ) { ?>

					<fieldset id="fop_gallery" class="panel-fieldset metabox-fieldset fop_toggle none"><legend><?php echo $section['title']; ?></legend>

						<dl>
							<dt>
								<span><?php echo $section['title']; ?></span>
							</dt>
							<dd>
								<input type="hidden" name="<?php echo $section['name']; ?>_value" value='<?php echo $section_value; ?>' id="st_gallery" style="width: 50%;" />
								<input type="button" value="<?php esc_attr_e( 'Delete', 'stkit' ) ?>" class="button<?php echo empty( $section_value ) ? ' none' : ''; ?>" id="st_gallery_delete">
								<input type="button" value="<?php empty( $section_value ) ? esc_attr_e( 'Create new', 'stkit' ) : esc_attr_e( 'Edit', 'stkit' ) ?>" data-create="<?php esc_attr_e( 'Create new', 'stkit' ) ?>" data-edit="<?php esc_attr_e( 'Edit', 'stkit' ) ?>" class="button" id="st_gallery_button">
								<ul id="st_gallery_thumbs" class="st_metabox_thumbs st-ajax-thumbs" <?php if ( $section_value ) echo 'data-ids="' . $section_value . '"'; ?>></ul>
							</dd>
						</dl>

					</fieldset><?php

				}


			}
	
		}


	/*-------------------------------------------
		1.3 - Register metabox
	-------------------------------------------*/

		function st_create_metabox_format() {

			global
				$st_MetaboxFormat;

				if ( function_exists('add_meta_box') ) :
	
					if ( wp_get_current_user()->has_cap('edit_posts') ) :
	
						add_meta_box( 'st-metabox-format', esc_attr__( 'Format Options', 'stkit' ), 'st_metabox_format', 'post', 'normal', 'high' );
	
					endif;
	
				endif;

		}

		add_action( 'admin_menu', 'st_create_metabox_format' );


	/*-------------------------------------------
		1.4 - Save data
	-------------------------------------------*/

		function st_save_post_formatdata( $post_id ) {
		
			global
				$post,
				$st_MetaboxFormat,
				$st_Kit;

				if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE )
					return $post_id;

				// for $st_MetaboxFormat
				foreach ( $st_MetaboxFormat as $section ) :

					// verify nonce
					if ( !isset( $_POST[$section['name'] . '_nonce'] ) || !wp_verify_nonce( $_POST[$section['name'] . '_nonce'], basename(__FILE__) ) )
						return $post_id; 

					// verify
					if ( !empty( $_POST['post_type'] ) && $_POST['post_type'] == 'page' ) :

						if ( !current_user_can( 'edit_page', $post_id ) ) :

							return $post_id;

						endif;

					else :

						if ( !current_user_can( 'edit_post', $post_id ) ) :

							return $post_id;

						endif;

					endif;


					$data = wp_kses( !empty( $_POST[$section['name'] . '_value'] ) ? $_POST[$section['name'] . '_value'] : '', $st_Kit['tags_allowed'] );


					if ( get_post_meta( $post_id, $section['name'] . '_value') == '' ) :

						add_post_meta( $post_id, $section['name'] . '_value', $data, true );

					elseif ( $data != get_post_meta($post_id, $section['name'] . '_value', true ) ) :

						update_post_meta( $post_id, $section['name'] . '_value', $data );

					elseif( $data == '' ) :

						delete_post_meta( $post_id, $section['name'] . '_value', get_post_meta( $post_id, $section['name'] . '_value', true ) );

					endif;


				endforeach;

		}

		add_action( 'save_post', 'st_save_post_formatdata' );


?>