<?php if ( !defined( 'ABSPATH' ) ) exit;

/*

	version 2.0

*/

class ST_Kit_Widget_Contact_Info extends WP_Widget {

	public function __construct() {
		$widget_ops = array( 'classname' => 'widget_st_kit_widget_contact_info', 'description' => esc_attr__( 'Share your contact information like an address, phone number, email etc.', 'stkit' ) );
		$control_ops = array( 'width' => 250, 'height' => 250 );
		parent::__construct( 'st_kit_widget_contact_info', esc_attr__( 'ST Get In Touch', 'stkit' ), $widget_ops, $control_ops );
	}



	/*===============================================
	
		F R O N T - E N D
		Widget
	
	===============================================*/

	public function widget( $args, $instance ) {

		global
			$st_Settings;

		// Make a custom $args['before_widget']
		$args['before_widget'] = str_replace( 'widget', 'widget widget-info' , $args['before_widget'] );
		echo $args['before_widget'];

			$st_['title'] = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
			$st_['intro'] = apply_filters( 'widget_text', empty( $instance['intro'] ) ? '' : $instance['intro'], $instance );
			$st_['address'] = empty( $instance['address'] ) ? '' : $instance['address'];
			$st_['phone'] = empty( $instance['phone'] ) ? '' : $instance['phone'];
			$st_['email'] = empty( $instance['email'] ) ? '' : $instance['email'];
			$st_['name'] = empty( $instance['name'] ) ? '' : $instance['name'];

			if ( !empty( $st_['title'] ) ) {
				echo $args['before_title'] . $st_['title'] . $args['after_title']; }

			// Intro
			if ( !empty( $st_['intro'] ) )
				echo wpautop( $st_['intro'] );

			echo '<address>';

				// Address
				if ( !empty( $st_['address'] ) )
					echo '<p class="widget-info-address"><span>' . esc_attr__( 'Address', 'stkit' ) . ': </span>' . $st_['address'] . '</p>';
	
				// Phone
				if ( !empty( $st_['phone'] ) ) 
					echo '<p class="widget-info-phone"><span>' . esc_attr__( 'Phone', 'stkit' ) . ': </span>' . $st_['phone'] . '</p>';
	
				// Email
				if ( !empty( $st_['email'] ) )
					echo '<p class="widget-info-email"><span>' . esc_attr__( 'Email', 'stkit' ) . ': </span><a class="mailto" href="mailto:' . $st_['email'] . '">' . $st_['email'] . '</a></p>';
	
				// Name
				if ( !empty( $st_['name'] ) )
					echo '<p class="widget-info-name"><span>' . esc_attr__( 'Name', 'stkit' ) . ': </span>' . $st_['name'] . '</p>';

			echo '</address>';

		echo $args['after_widget'];

	}



	/*===============================================
	
		U P D A T E
		Sanitize widget form values as they are saved
	
	===============================================*/

	public function update( $new_instance, $old_instance ) {

		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['intro'] = strip_tags( $new_instance['intro'] );
		$instance['address'] = strip_tags( $new_instance['address'] );
		$instance['phone'] = strip_tags( $new_instance['phone'] );
		$instance['email'] = strip_tags( $new_instance['email'] );
		$instance['name'] = strip_tags( $new_instance['name'] );

		return $instance;

	}



	/*===============================================
	
		B A C K - E N D
		Controls
	
	===============================================*/

	public function form( $instance ) {

		$instance = wp_parse_args( (array) $instance, array(
			'title'					=> '',
			'intro'					=> '',
			'address'				=> '',
			'phone'					=> '',
			'email'					=> '',
			'name'					=> '',
			)
		);

		$st_['title'] = strip_tags( $instance['title'] );
		$st_['intro'] = strip_tags( $instance['intro'] );
		$st_['address'] = strip_tags( $instance['address'] );
		$st_['phone'] = strip_tags( $instance['phone'] );
		$st_['email'] = strip_tags( $instance['email'] );
		$st_['name'] = strip_tags( $instance['name'] );

		?>

			<fieldset class="panel-fieldset metabox-fieldset">
				<legend><?php esc_attr_e( 'Widget', 'stkit' ) ?></legend>

					<dl>
						<dt>
							<span><?php esc_attr_e( 'Title', 'stkit' ); ?></span>
						</dt>
						<dd>
							<input type="text" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo esc_attr( $st_['title'] ); ?>" />
							<small><?php esc_attr_e( 'Widget title.', 'stkit' ); ?></small>
						</dd>
					</dl>

				<div class="clear"><!-- --></div>
			</fieldset>

			<fieldset class="panel-fieldset metabox-fieldset">
				<legend><?php esc_attr_e( 'Contacts', 'stkit' ) ?></legend>

					<!-- Introduce -->

						<textarea class="no-resize" rows="4" cols="20" name="<?php echo $this->get_field_name( 'intro' ); ?>" ><?php echo $st_['intro']; ?></textarea>
						<p><small><?php esc_attr_e( 'Enter an introduce text or leave it blank.', 'stkit' ); ?></small></p>
						<div class="clear"><!-- --></div>


					<!-- Address -->

						<dl>
							<dt>
								<span><?php esc_attr_e( 'Address', 'stkit' ); ?></span>
							</dt>
							<dd>
								<input type="text" name="<?php echo $this->get_field_name( 'address' ); ?>" value="<?php echo $st_['address']; ?>" />
								<div class="clear"><!-- --></div>			
							</dd>
						</dl>


					<!-- Phone -->

						<dl>
							<dt>
								<span><?php esc_attr_e( 'Phone', 'stkit' ); ?></span>
							</dt>
							<dd>
								<input type="text" name="<?php echo $this->get_field_name( 'phone' ); ?>" value="<?php echo $st_['phone']; ?>" />
								<div class="clear"><!-- --></div>
							</dd>
						</dl>


					<!-- Email -->

						<dl>
							<dt>
								<span><?php esc_attr_e( 'Email', 'stkit' ); ?></span>
							</dt>
							<dd>
								<input type="text" name="<?php echo $this->get_field_name( 'email' ); ?>" value="<?php echo $st_['email']; ?>" />
								<div class="clear"><!-- --></div>
							</dd>
						</dl>


					<!-- Name -->

						<dl>
							<dt>
								<span><?php esc_attr_e( 'Name', 'stkit' ); ?></span>
							</dt>
							<dd>
								<input type="text" name="<?php echo $this->get_field_name( 'name' ); ?>" value="<?php echo $st_['name']; ?>" />
							</dd>
						</dl>

				<div class="clear"><!-- --></div>
			</fieldset>




		<?php
	}



} // class ST_Kit_Widget_Contact_Info

function st_kit_widget_contact_info_init() {

	register_widget('ST_Kit_Widget_Contact_Info');

	//do_action( 'widgets_init' );

}
add_action( 'widgets_init', 'st_kit_widget_contact_info_init', 1 );


?>