<?php if ( !defined( 'ABSPATH' ) ) exit;

/*

	version 2.0

*/

class ST_Kit_Widget_Subscribe extends WP_Widget {

	public function __construct() {
		$widget_ops = array( 'classname' => 'widget_st_kit_widget_subscribe', 'description' => esc_attr__( 'Allow visitors to subscribe to your website via FeedBurner.', 'stkit' ) );
		$control_ops = array( 'width' => 250, 'height' => 250 );
		parent::__construct( 'st_kit_widget_subscribe', esc_attr__( 'ST Subscribe', 'stkit' ), $widget_ops, $control_ops );
	}



	/*===============================================
	
		F R O N T - E N D
		Widget
	
	===============================================*/

	public function widget( $args, $instance ) {

		global
			$st_Settings;

		// Make a custom $args['before_widget']
		$args['before_widget'] = str_replace( 'widget', 'widget widget-subscribe' , $args['before_widget'] );
		echo $args['before_widget'];

			$st_['title'] = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'], $instance, $this->id_base );
			$st_['feedId'] = empty( $instance['feedId'] ) ? '' : $instance['feedId'];
			$st_['descr'] = apply_filters( 'widget_text', empty( $instance['descr'] ) ? '' : $instance['descr'], $instance );

			if ( !empty( $st_['title'] ) ) {
				echo $args['before_title'] . $st_['title'] . $args['after_title']; }


				echo wpautop( $st_['descr'] );
	
				?>

					<form class="feedemail-form" action="//feedburner.google.com/fb/a/mailverify" method="post" target="popupwindow" onsubmit="window.open('//feedburner.google.com/fb/a/mailverify?uri=<?php echo $st_['feedId'] ?>', 'popupwindow', 'scrollbars=yes,width=600,height=550');return true">
						<div>
							<input type="text" class="feedemail-input" name="email" maxlength="150" value="" placeholder="<?php esc_attr_e( 'your.email@address', 'stkit' ) ?>" />
							<input type="hidden" value="<?php echo $st_['feedId'] ?>" name="uri"/>
							<input type="hidden" name="loc" value="<?php echo str_replace('-', '_', get_bloginfo( 'language' ) ) ?>"/>
							<input type="submit" value="<?php esc_attr_e( 'Subscribe', 'stkit' ) ?>" class="feedemail-button"/>
						</div>
					</form>

					<div class="clear"><!-- --></div>

				<?php

	

		echo $args['after_widget'];

	}



	/*===============================================
	
		U P D A T E
		Sanitize widget form values as they are saved
	
	===============================================*/

	public function update( $new_instance, $old_instance ) {

		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['feedId'] = strip_tags($new_instance['feedId']);
		$instance['descr'] = strip_tags($new_instance['descr']);

		return $instance;

	}



	/*===============================================
	
		B A C K - E N D
		Controls
	
	===============================================*/

	public function form( $instance ) {

		$instance = wp_parse_args( (array) $instance, array(
			'title'					=> '',
			'feedId'				=> '',
			'descr'					=> '',
			)
		);

		$st_['title'] = strip_tags( $instance['title'] );
		$st_['feedId'] = strip_tags( $instance['feedId'] );
		$st_['descr'] = $instance['descr'] ? strip_tags( $instance['descr'] ) : esc_attr__( 'Sign up for our newsletter to receive the latest news and event postings.', 'stkit' );


		?>

			<fieldset class="panel-fieldset metabox-fieldset"><legend><?php esc_attr_e( 'Title', 'stkit' ) ?></legend>

				<input type="text" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo esc_attr( $st_['title'] ); ?>" />
				<small><?php esc_attr_e( 'Widget title.', 'stkit' ); ?></small>

			</fieldset>

			<fieldset class="panel-fieldset metabox-fieldset">
				<legend><?php esc_attr_e( 'Feedburner', 'stkit' ) ?></legend>
		
				<input type="text" name="<?php echo $this->get_field_name( 'feedId' ); ?>" value="<?php echo esc_attr( $st_['feedId'] ); ?>" />
				<small><?php esc_attr_e( 'Enter you Feedburner ID', 'stkit' ); ?></small>
		
				<div class="clear"><!-- --></div>
			</fieldset>
		
			<fieldset class="panel-fieldset metabox-fieldset">
				<legend><?php esc_attr_e( 'Email-subscribe', 'stkit' ); ?></legend>

				<textarea rows="4" cols="20" name="<?php echo $this->get_field_name( 'descr' ); ?>" ><?php echo esc_attr( $st_['descr'] ); ?></textarea>
				<small><?php esc_attr_e( 'Description', 'stkit' ); ?></small>
		
				<div class="clear"><!-- --></div>
		
			</fieldset>

		<?php
	}



} // class ST_Kit_Widget_Subscribe

function st_kit_widget_subscribe_init() {

	register_widget('ST_Kit_Widget_Subscribe');

	//do_action( 'widgets_init' );

}
add_action( 'widgets_init', 'st_kit_widget_subscribe_init', 1 );


?>