<?php if ( !defined( 'ABSPATH' ) ) exit;

/*

	1 - GLOBAL

		1.1 - Post formats

	2 - FILTERS

		2.1 - Google Analytics
		2.2 - Remove admin bar
		2.3 - Excerpt lenght
		2.4 - Stop breaking shortcodes
		2.5 - Install Google font
		2.6 - Include post formats to RSS-feed
		2.7 - Hatom-feed
		2.8 - Do shortcodes on BP activity
		2.9 - Wrap content by 'article' tag
		2.10 - Add the articleEnd
		2.11 - Smooth scroll
		2.12 - HiDPI

	3 - ACTIONS

		3.1 - Theme Panel links on Admin Bar
		3.2 - Do shortcodes on...
		3.3 - Alt classes body class
		3.4 - Attachments update
		3.5 - Dequeue WP-Pagenavi stiles
		3.6 - Hide & re-define WP-Review
		3.7 - Mediaelement
		3.8 - CTP taxonomy archive
		3.9 - Category image
		3.10 - Category sidebar
		3.11 - Category sidebar 2
		3.12 - Category sidebar position
		3.13 - Category blogroll

	4 - FUNCTIONS

		4.1 - Post views
		4.2 - Nice time
		4.3 - Icons the Social
		4.4 - Path of custom.css file
		4.5 - Get a first image from post
		4.6 - Write Custom CSS
		4.7 - Get 2x image URL
		4.8 - Get post format icon
		4.9 - Custom Background Callback
		4.10 - Adjust Color Brightness
		4.11 - Related posts
		4.12 - Get authors by post count
		4.13 - Post social share
		4.14 - ST Kit allowed tags
		4.15 - schema.org itemscope
		4.16 - HEX to RGB
		4.17 - st_wp_update_nav_menu_item

	5 - WOOCOMMERCE

		5.1 - Add WooCommerce support
		5.2 - Remove WooCommerce prettyPhoto
		5.3 - Re-define number of products per row
		5.4 - Define image sizes
		5.5 - Define number of products per page
		5.6 - Define number of related products
		5.7 - Register CSS
		5.8 - Remove JS & CSS from irrelevant pages

*/

/*= 1 ===========================================

	G L O B A L
	Required WordPress settings

===============================================*/

	global
		$st_Settings,
		$st_Options;

	if ( file_exists( get_stylesheet_directory() . '/options.php' ) )
		include( get_stylesheet_directory() . '/options.php' );
	elseif ( file_exists( get_template_directory() . '/options.php' ) )
		include( get_template_directory() . '/options.php' );



	/*-------------------------------------------
		1.1 - Post formats
	-------------------------------------------*/

	if ( $st_Options['global']['post-formats']['enabled'] ) {

		foreach ( $st_Options['global']['post-formats'] as $st_['format'] => $key ) {
			if ( $key['status'] )
				$st_['post-formats'][] = $st_['format'];

		}

		add_theme_support( 'post-formats', $st_['post-formats'] );

	}



/*= 2 ===========================================

	F I L T E R S
	Permanent custom filters

===============================================*/

	/*-------------------------------------------
		2.1 - Google Analytics
	-------------------------------------------*/

	function st_ga() {

		global
			$st_Options,
			$st_Settings;

			if ( $st_Options['panel']['major']['general']['analytics'] == true && !empty( $st_Settings['google_analytics'] ) ) {

				$ga = explode( 'script>', $st_Settings['google_analytics'] );

				if ( $ga[1] )
					echo $st_Settings['google_analytics'];
				else
					echo '<script>' . $st_Settings['google_analytics'] . '</script>' . "\n";

			}

	}

	add_filter( 'wp_head', 'st_ga', 100 );



	/*-------------------------------------------
		2.2 - Remove admin bar
	-------------------------------------------*/

	if ( !empty( $st_Settings['admin_bar'] ) && $st_Settings['admin_bar'] == 'no' ) {

		function st_function_admin_bar() { return false; }

		add_filter( 'show_admin_bar' , 'st_function_admin_bar' );

	}



	/*-------------------------------------------
		2.3 - Excerpt lenght
	-------------------------------------------*/

	function st_excerpt_length( $length = NULL ) {

		global
			$st_Options;

			$length = $length ? $length : $st_Options['global']['excerpt'];

		return
			$length;

	}

	add_filter( 'excerpt_length', 'st_excerpt_length' );



	/*-------------------------------------------
		2.4 - Stop breaking shortcodes
	-------------------------------------------*/

	function st_shortcode_fix( $content ) {

		$array = array (
			'<p>['		=> '[',
			']</p>'		=> ']',
			']<br />'	=> ']',
			']<br/>'	=> ']',
			']<br>'		=> ']',
			);

		$content = strtr( $content, $array );

		return $content;

	}

	add_filter( 'the_content', 'st_shortcode_fix' );



	/*-------------------------------------------
		2.5 - Install Google font
	-------------------------------------------*/

	// Font A
	if ( !empty( $st_Settings['font_type'] ) && $st_Settings['font_type'] == 'custom' && !empty( $st_Settings['font_custom_code'] ) ) {

		function st_font_custom_script_a() {

			global
				$st_Settings;

				$st_['family'] = explode( "family=", $st_Settings['font_custom_code'] );

				if ( $st_['family'][1] ) {

					$st_['family'] = explode( "'", str_replace( '+', ' ', $st_['family'][1] ) );

					$st_['family_url'] = add_query_arg( 'family', urlencode( $st_['family'][0] ), "//fonts.googleapis.com/css" );

					wp_enqueue_style( 'st-font-custom', $st_['family_url'], false, null, 'all' );

				}

		}

		add_action( 'wp_enqueue_scripts', 'st_font_custom_script_a' );

	}

	// Font B
	if ( !empty( $st_Settings['font_type'] ) && $st_Settings['font_type'] == 'custom' && !empty( $st_Settings['font_custom_code_2'] ) ) {

		function st_font_custom_script_b() {

			global
				$st_Settings;

				$st_['family'] = explode( "family=", $st_Settings['font_custom_code_2'] );

				if ( $st_['family'][1] ) {

					$st_['family'] = explode( "'", str_replace( '+', ' ', $st_['family'][1] ) );

					$st_['family_url'] = add_query_arg( 'family', urlencode( $st_['family'][0] ), "//fonts.googleapis.com/css" );

					wp_enqueue_style( 'st-font-custom-2', $st_['family_url'], false, null, 'all' );

				}

		}

		add_action( 'wp_enqueue_scripts', 'st_font_custom_script_b' );

	}



	/*-------------------------------------------
		2.6 - Include post formats to RSS-feed
	-------------------------------------------*/

	function st_feed_post_format( $content ) {

		global
			$post,
			$st_Options,
			$st_Settings;

			$prefix = !empty( $st_Options['general']['prefix'] ) ? $st_Options['general']['prefix'] : 'st-';

			if ( !empty( $st_Options['global']['images']['project-medium'] ) ) {
				$content_width = $st_Options['global']['images']['project-medium']['width']; }
			else {
				$content_width = $st_Options['global']['images'][$prefix . 'project-medium']['width']; } // st-thumbnail since v.1.7.6


			$st_ = array();

			// Post format
			$st_['format'] = get_post_format( $post->ID ) ? get_post_format( $post->ID ) : 'standard';

			// Format: Standard, Image
			if ( $st_['format'] == 'standard' && !empty( $st_Settings['post_feat_image'] ) == 'yes' || $st_['format'] == 'image' ) {

				if ( has_post_thumbnail( $post->ID ) )
					$content = '<div>' . get_the_post_thumbnail( $post->ID, ( !empty( $st_Options['global']['images']['post-image'] ) ? 'post-image' : $prefix . 'post-image' ) ) . '</div>' . $content;

			}

			// Format: Gallery
			if ( $st_['format'] == 'gallery' ) {

				if ( empty( $st_Settings['shortcodes'] ) || isset( $st_Settings['shortcodes'] ) && $st_Settings['shortcodes'] != 'no' ) {

					$st_['ids'] = st_get_post_meta( $post->ID, 'gallery_value', true, '' );

					if ( $st_['ids'] ) {
						$st_['gallery'] = str_replace( '/>', '/><br />', do_shortcode( '[st-gallery ids="' . $st_['ids'] . '"]' ) ); }

					$content = '<div>' . $st_['gallery'] . '</div>' . $content;

				}

			}

			// Format: Audio
			if ( $st_['format'] == 'audio' ) {

				$st_['mp3'] = st_get_post_meta( $post->ID, 'mp3_value', true, '' ) ? ' mp3="' . st_get_post_meta( $post->ID, 'mp3_value', true, '' ) . '"' : '';
				$st_['ogg'] = st_get_post_meta( $post->ID, 'ogg_value', true, '' ) ? ' ogg="' . st_get_post_meta( $post->ID, 'ogg_value', true, '' ) . '"' : '';
				$st_['audio'] = st_get_post_meta( $post->ID, 'audio_value', true, '' );

				if ( $st_['audio'] )
					$content = '<div>' . $st_['audio'] . '</div>' . $content;

				elseif ( $st_['mp3'] || $st_['ogg'] )
					$content = '<div>' . do_shortcode('[audio' . $st_['mp3'] . $st_['ogg'] . ' preload=none]') . '</div>' . $content;

			}

			// Format: Video
			if ( $st_['format'] == 'video' ) {

				$st_['mp4'] = st_get_post_meta( $post->ID, 'mp4_value', true, '' ) ? ' mp4="' . st_get_post_meta( $post->ID, 'mp4_value', true, '' ) . '"' : '';
				$st_['ogv'] = st_get_post_meta( $post->ID, 'ogv_value', true, '' ) ? ' ogv="' . st_get_post_meta( $post->ID, 'ogv_value', true, '' ) . '"' : '';
				$st_['webm'] = st_get_post_meta( $post->ID, 'webm_value', true, '' ) ? ' webm="' . st_get_post_meta( $post->ID, 'webm_value', true, '' ) . '"' : '';
				$st_['video'] = st_get_post_meta( $post->ID, 'video_value', true, '' );

				if ( $st_['video'] ) {
					$content = '<div>' . $st_['video'] . '</div>' . $content; }

				elseif ( $st_['mp4'] || $st_['ogv'] || $st_['webm'] ) {

					$st_['poster'] = wp_get_attachment_image_src( get_post_thumbnail_id(), ( !empty( $st_Options['global']['images']['large'] ) ? 'large' : $prefix . 'large' ) ); // st-thumbnail since v.1.7.6
						$st_['poster'] = $st_['poster'] ? ' poster=' . $st_['poster'][0] : '';

					$content = '<div>' . do_shortcode('[video' . $st_['mp4'] . $st_['ogv'] . $st_['webm'] . ' preload=none ' . $st_['poster'] . ']') . '</div>' . $content;

				}

			}

			// Format: Link
			if ( $st_['format'] == 'Link' ) {

				$st_['link'] = st_get_post_meta( $post->ID, 'link_value', true, '' );

				if ( $st_['link'] ) {

					$st_['link_title'] = st_get_post_meta( $post->ID, 'link_title_value', true, $st_['link'] );

					$content = '<div><p style="font-size: 120%;"><a href="' . $st_['link'] . '">' . $st_['link_title'] . '</a></p></div>' . $content;

				}

			}

			// Format: Quote
			if ( $st_['format'] == 'quote' ) {

				$st_['quote'] = st_get_post_meta( $post->ID, 'quote_value', true, '' );

				if ( $st_['quote'] )
					$content = '<blockquote><p style="font-size: 120%;">' . $st_['quote'] . '</p></blockquote>' . $content;

			}

		return $content;

	}

	add_filter( 'the_excerpt_rss', 'st_feed_post_format', 1000, 1 );
	add_filter( 'the_content_feed', 'st_feed_post_format', 1000, 1 );



	/*-------------------------------------------
		2.7 - Hatom-feed
	-------------------------------------------*/

	function st_the_content_hatom( $content ) {

		global
			$post;

		if ( is_singular() && is_main_query() )
			$content .= "\n\n" . '<div class="none"><time class="date updated" datetime="' . get_the_time( 'o-m-d' ) . '" data-pubdate>' . get_the_time( 'M j, Y' ) . '</time><span class="author vcard"><span class="fn">' . get_the_author_meta( "display_name" ) . '</span></span></div>';

		return $content;

	}

	add_filter( 'the_content', 'st_the_content_hatom', 9 );



	/*-------------------------------------------
		2.8 - Do shortcodes on BP activity
	-------------------------------------------*/

	function st_activity_content_shortcodes( $activity_content ) {

		return do_shortcode( $activity_content );

	}
	add_filter( 'bp_get_activity_content_body', 'st_activity_content_shortcodes', 4 );



	/*-------------------------------------------
		2.9 - Wrap content by 'article' tag
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['st_the_content_article'] ) == true ) {

		function st_the_content_article( $content ) {

			global
				$post;

				if ( is_singular() && is_main_query() ) {

					$content = '<article>' . "\n\n" . $content . "\n\n" . '</article>';

				}

				return $content;

		}

		add_filter( 'the_content', 'st_the_content_article', 9 );

	}



	/*-------------------------------------------
		2.10 - Add the articleEnd
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['st_the_content_article_end'] ) == true ) {

		function st_the_content_article_end( $content ) {

			global
				$post;

				if ( is_singular() && is_main_query() ) {

					$content = $content . "\n\n" . '<div id="articleEnd"><!-- --></div>';

				}

				return $content;

		}

		add_filter( 'the_content', 'st_the_content_article_end', 999 );

	}



	/*-------------------------------------------
		2.11 - Smooth scroll
	-------------------------------------------*/

	function st_smoothscroll_body_class( $classes ) {

		global
			$st_Options,
			$st_Settings;

		if ( !empty( $st_Options['panel']['misc']['smooth-scroll'] ) ) {
			if ( !empty( $st_Settings['smooth-scroll'] ) == 'yes' ) {
				$classes[] = 'smooth-scroll';
			}
		}

		return
			$classes;

	}

	add_filter( 'body_class', 'st_smoothscroll_body_class' );



	/*-------------------------------------------
		2.12 - HiDPI
	-------------------------------------------*/

	function st_hidpi_body_class( $classes ) {

		global
			$st_Options,
			$st_Settings;

		if ( $st_Options['panel']['misc']['hidpi'] && !isset( $st_Settings['hidpi'] ) || !empty( $st_Settings['hidpi'] ) != 'no' )
			$classes[] = 'hidpi-on';

		return
			$classes;

	}

	add_filter( 'body_class', 'st_hidpi_body_class' );



/*= 3 ===========================================

	A C T I O N S
	Permanent custom actions

===============================================*/

	/*-------------------------------------------
		3.1 - Theme Panel links on Admin Bar
	-------------------------------------------*/

	function st_admin_bar_init() {

		if ( current_user_can( 'edit_theme_options' ) ) {

			function st_admin_bar( $admin_bar ) {

				global
					$st_Options;


					$args = array(
						'id'		=> 'st-panel',
						'title'		=> esc_attr__( 'Theme Panel', 'stkit' ),
						'href'		=> admin_url( 'admin.php?page=st-major-settings'),
						'parent'	=> 'site-name',
					);
					$admin_bar->add_menu( $args);

						// Main Settings
						$args = array(
							'id'		=> 'st-panel-major',
							'title'		=> esc_attr__( 'Main Settings', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-major-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['major']['status'] )
							$admin_bar->add_menu( $args );

						// Projects
						$args = array(
							'id'		=> 'st-panel-projects',
							'title'		=> esc_attr__( 'Projects', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-projects-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['projects']['status'] )
							$admin_bar->add_menu( $args );

						// Layout
						$args = array(
							'id'		=> 'st-panel-layout',
							'title'		=> esc_attr__( 'Layout', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-layout-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['layout']['status'] )
							$admin_bar->add_menu( $args );

						// Fonts
						$args = array(
							'id'		=> 'st-panel-fonts',
							'title'		=> esc_attr__( 'Fonts', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-fonts-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['fonts']['status'] )
							$admin_bar->add_menu( $args );

						// Style
						$args = array(
							'id'		=> 'st-panel-style',
							'title'		=> esc_attr__( 'Style', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-style-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['style']['status'] )
							$admin_bar->add_menu( $args );

						// Miscellaneous
						$args = array(
							'id'		=> 'st-panel-misc',
							'title'		=> esc_attr__( 'Miscellaneous', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-misc-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['misc']['status'] )
							$admin_bar->add_menu( $args );

						// Import Export
						$args = array(
							'id'		=> 'st-panel-import',
							'title'		=> esc_attr__( 'Import / Export', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-import-settings'),
							'parent'	=> 'st-panel',
						);
						if ( $st_Options['panel']['import']['status'] )
							$admin_bar->add_menu( $args );

						// Update
						$args = array(
							'id'		=> 'st-panel-update',
							'title'		=> esc_attr__( 'Update', 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-update-settings'),
							'parent'	=> 'st-panel',
						);

						if ( isset($st_Options['panel']['update']) && $st_Options['panel']['update']['status'] )
							$admin_bar->add_menu( $args );

						// What's NEW
						$args = array(
							'id'		=> 'st-panel-whats-new',
							'title'		=> esc_attr__( "What's NEW", 'stkit' ),
							'href'		=> admin_url( 'admin.php?page=st-whats-new-settings'),
							'parent'	=> 'st-panel',
						);
						$admin_bar->add_menu( $args );

			}

			add_action( 'admin_bar_menu', 'st_admin_bar', 100 );

		}

	}

	add_action( 'init', 'st_admin_bar_init', 100 );



	/*-------------------------------------------
		3.2 - Do shortcodes on..
	-------------------------------------------*/

	add_filter( 'widget_text', 'do_shortcode' );
	add_filter( 'the_excerpt', 'do_shortcode' );



	/*-------------------------------------------
		3.3 - Alt classes body class
	-------------------------------------------*/

	function st_body_class( $classes ) {

		global
			$st_Options,
			$st_Settings;

			// Alt styles
			$alt = !empty( $st_Settings['style'] ) ? $st_Settings['style'] : '';

			if ( $alt && $alt != 'light' )
				$classes[] = $alt;

			// StrictThemes font enabled
			if ( !empty( $st_Options['font-st'] ) == true )
				$classes[] = 'font-st';

			// Boxed layout
			if ( !empty( $st_Settings['layout_design'] ) && $st_Settings['layout_design'] == 'boxed' )
				$classes[] = 'boxed';

		return $classes;

	}

	add_filter( 'body_class', 'st_body_class' );



	/*-------------------------------------------
		3.4 - Attachments update
	-------------------------------------------*/

	function st_attachments_ajax_update( $ids = '', $li = true, $echo = true ) {

		if ( $ids )
			$ids = explode( ',', $ids );

		elseif ( !empty( $_POST['ids'] ) )
			$ids = wp_kses( $_POST['ids'], array() );

			if ( $ids ) {

				$return = '';

				$args = array(
					'post_type'			=> 'attachment',
					'post_status'		=> 'inherit',
					'post__in'			=> $ids,
					'post_mime_type'	=> 'image',
					'posts_per_page'	=> '-1',
					'orderby'			=> 'post__in'
				);

				$query = new WP_Query( $args );
				wp_reset_postdata();

				if ( $query->have_posts() ) {

					while ( $query->have_posts() ) {

						$query->the_post();

						$return .= ( $li ? '<li>' : '' );

							//$thumbnail = wp_get_attachment_image_src( $query->post->ID, ( !empty( $st_Options['global']['images']['thumbnail'] ) ? 'thumbnail' : ( !empty( $st_Options['general']['prefix'] ) ? $st_Options['general']['prefix'] . 'thumbnail' : 'st-thumbnail' ) ) ); // st-thumbnail since v.1.7.6
							$thumbnail = wp_get_attachment_image_src( $query->post->ID, 'thumbnail' ); // thumbnail since v.1.9.0
							$return .= '<img src="' . $thumbnail[0] . '" width="60" height="60" />';

						$return .= ( $li ? '</li>' : '' );

					}

				}

				else {

					$return .= '.';

				}

				if ( $echo == true )
					echo $return;
				else
					return $return;

				if ( !empty( $_POST['ids'] ) )
					exit();

			}

		return;

	}

	add_action( 'wp_ajax_attachments_update', 'st_attachments_ajax_update' );



	/*-------------------------------------------
		3.5 - Dequeue WP-Pagenavi stiles
	-------------------------------------------*/

	function st_pagenavi_dequeue_assets() {

		wp_deregister_style( 'wp-pagenavi' );

	}

	add_action( 'wp_print_styles', 'st_pagenavi_dequeue_assets', 100 );



	/*-------------------------------------------
		3.6 - Hide & re-define WP-Review
	-------------------------------------------*/

	if ( !empty( $st_Options['compatibility']['wp-review'] ) ) {

		// Hide unnecessary controls
		if ( !empty( $st_Options['compatibility']['wp-review']['hide'] ) ) {

			function st_mts_hide_item_metabox_fields( $fields ) {

				global
					$st_Options;

					foreach ( $st_Options['compatibility']['wp-review']['hide'] as $key )
						unset( $fields[$key] );

					return $fields;

			}

			add_filter( 'wp_review_metabox_item_fields', 'st_mts_hide_item_metabox_fields' );

		}

		// Exclude post types
		if ( !empty( $st_Options['compatibility']['wp-review']['exclude'] ) ) {

			function st_mts_wp_review_exclude_post_types( $excluded ) {

				global
					$st_Options;

					foreach ( $st_Options['compatibility']['wp-review']['exclude'] as $key )
						$excluded[] = $key;

					return $excluded;

			}

			add_filter( 'wp_review_excluded_post_types', 'st_mts_wp_review_exclude_post_types' );

		}

		// De-register default styles due it hasn't been loaded through action
		function st_wp_review_enqueue() {

			wp_dequeue_style( 'wp_review-style' );
			wp_deregister_style( 'wp_review_tab_widget' );
			wp_deregister_style( 'wp_review-style' );

		}

		add_action( 'wp_enqueue_scripts', 'st_wp_review_enqueue', 100 );

		// And de-register default styles from within certain function
		function st_wp_review_show_total( $review ) {

			wp_dequeue_style( 'wp_review-style' );
			wp_deregister_style( 'wp_review_tab_widget' );
			wp_deregister_style( 'wp_review-style' );

			return $review;

		}

		add_filter( 'wp_review_show_total', 'st_wp_review_show_total' );

		// Remove plain CSS from post content
		function st_wp_review_color_output() {
			return;
		}

		add_filter( 'wp_review_color_output', 'st_wp_review_color_output' );

		// Remove banner
		add_filter( 'wp_review_remove_branding', '__return_true' );

	}



	/*-------------------------------------------
		3.7 - Mediaelement
	-------------------------------------------*/

	function st_mediaelement() {

		// Deregister default buggy version
		wp_dequeue_script( 'wp-mediaelement' );
		wp_deregister_script( 'mediaelement' );
		wp_deregister_style( 'mediaelement' );
		wp_deregister_style( 'wp-mediaelement' );

		// Register valid version
		wp_enqueue_style( 'mediaelement', plugins_url( 'stkit' ) . '/assets/plugins/mediaelement/mediaelementplayer.min.css', false, null, 'all' );
		//wp_enqueue_style( 'wp-mediaelement', plugins_url( 'stkit' ) . '/assets/plugins/mediaelement/wp-mediaelement.css', false, null, 'all' );
		wp_enqueue_script( 'mediaelement', plugins_url( 'stkit' ) . '/assets/plugins/mediaelement/mediaelement-and-player.min.js', array('jquery'), null, true );
		//wp_enqueue_script( 'wp-mediaelement', plugins_url( 'stkit' ) . '/assets/plugins/mediaelement/wp-mediaelement.js', array('jquery'), null, true );

	}

	if ( !empty( $st_Options['js']['mediaelement'] ) && !is_admin() )
		add_action( 'wp_enqueue_scripts', 'st_mediaelement', 11 );



	/*-------------------------------------------
		3.8 - CTP taxonomy archive
	-------------------------------------------*/

	if ( !empty( $st_Options['ctp']['query'] ) == 'main' ) {

		function st_ctp_taxonomy_archive( $query ) {

			global
				$st_Options,
				$st_Settings;

				// Post type names
				$st_['st_category'] = !empty( $st_Settings['ctp_category'] ) ? $st_Settings['ctp_category'] : $st_Options['ctp']['category'];
				$st_['st_tag'] = !empty( $st_Settings['ctp_tag'] ) ? $st_Settings['ctp_tag'] : $st_Options['ctp']['tag'];

				// Projects per page
				$st_['projects_per_page'] = !empty( $st_Settings['projects_qty'] ) ? $st_Settings['projects_qty'] : $st_Options['ctp']['qty'];

				if ( $query->is_main_query() ) {
					if ( is_tax( $st_['st_category'] ) || is_tax( $st_['st_tag'] ) )
						$query->set( 'posts_per_page', $st_['projects_per_page'] );
				}

		}

		add_action( 'pre_get_posts', 'st_ctp_taxonomy_archive' );

	}



	/*-------------------------------------------
		3.9 - Category image
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['category-image'] ) == true ) {

		// Add
		function st_category_image_field_add( $taxonomy ) {

			$st_['out'] =
				'<div class="form-field">
					<label for="st_category_image">' . esc_attr__( 'Category image', 'stkit' ) . '</label>
					<input name="st_category_image" id="st_category_image" type="text" value="" size="40" aria-required="true" />
					<p class="description">' . esc_attr__( 'Image URL path.', 'stkit' ) . '</p>
				</div>';

			$st_['out'] =
				'<tr class="form-field">
					<th scope="row" valign="top"><label for="st_category_image">' . esc_attr__( 'Image', 'stkit' ) . '</label></th>
					<td>

						<ul id="st_category_image_thumb" class="st_metabox_thumbs st-ajax-thumbs"></ul>

						<input type="button" value="' . esc_attr__( 'Select Image', 'stkit' ) . '" class="button" id="st_category_image_button">

						<p>' . esc_attr__( 'Attach an image related with.', 'stkit' ) . '</p>

						<input type="hidden" name="st_category_image" id="st_category_image" value="" />

						<br>
					</td>
				</tr>';

			$st_['out'] .=
				'<style type="text/css" media="screen">
					.st-category-thumb {
						display: inline-block;
						padding: 5px;
						background: #FFF;
						border: 1px solid #DDD;
						border-radius: 2px;
					}
						.st-category-thumb img {
							display: block;
						}
				</style>';

			echo $st_['out'];

		}

		add_action( 'category_add_form_fields', 'st_category_image_field_add', 10 );

		// Edit
		function st_category_image_field_edit( $tag, $taxonomy ) {

			$st_['value'] = 'st_category_image_' . $tag->term_id;
			$st_['st_category_image'] = get_option( $st_['value'] );

			$st_['out'] =
				'<tr class="form-field">
					<th scope="row" valign="top"><label for="st_category_image">' . esc_attr__( 'Image', 'stkit' ) . '</label></th>
					<td>

						<a id="st_category_image_delete" ' . ( !$st_['st_category_image'] ? 'class="none"' : '' ) . 'href="#"></a>

						<ul id="st_category_image_thumb" class="st_metabox_thumbs st-ajax-thumbs" ' . ( $st_['st_category_image'] ? 'data-ids="' . $st_['st_category_image'] . '"' : '' ) . '></ul>

						<input type="button" value="' . esc_attr__( 'Select Image', 'stkit' ) . '" class="button" id="st_category_image_button">

						<input type="hidden" name="st_category_image" id="st_category_image" value="' . ( $st_['st_category_image'] ? $st_['st_category_image'] : '' ) . '" />

						<br>
					</td>
				</tr>';

			echo $st_['out'];

		}

		add_action( 'category_edit_form_fields', 'st_category_image_field_edit', 10, 2 );

		// Save
		function st_category_image_field_save( $term_id ) {

			if ( isset( $_POST['st_category_image'] ) ) {

				$st_['value'] = 'st_category_image_' . $term_id;
				update_option( $st_['value'], $_POST['st_category_image'] );

			}

		}

		add_action( 'created_category', 'st_category_image_field_save', 10, 2 );
		add_action( 'edited_category', 'st_category_image_field_save', 10, 2 );

		// JS
		function st_category_image_media() {
			wp_enqueue_media();
		}

		add_action( 'admin_enqueue_scripts', 'st_category_image_media' );

		// Category image thumbnail
		function st_category_image_columns( $columns ) {

			$new_columns = array();
			$new_columns['cb'] = $columns['cb'];
			$new_columns['thumb'] = esc_attr__('Image', 'zci');
			unset( $columns['cb'] );
			unset( $columns['description'] );

			return
				array_merge( $new_columns, $columns );

		}

		add_filter( 'manage_edit-category_columns', 'st_category_image_columns' );

		// Category image thumbnail
		function st_category_custom_columns( $columns, $column, $id ) {

			if ( $column == 'thumb' ) {

				$st_['st_category_image'] = get_option( 'st_category_image_' . $id );

				if ( $st_['st_category_image'] )
					$columns = '<a class="st-category-thumb" href="edit-tags.php?action=edit&taxonomy=category&tag_ID=' . $id . '">' . st_attachments_ajax_update ( $st_['st_category_image'], false, false ) . '</a>';

			}

			return $columns;

		}

		add_action( 'manage_category_custom_column', 'st_category_custom_columns', 10, 3 );

	}



	/*-------------------------------------------
		3.10 - Category sidebar
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['category-sidebar'] ) == true ) {

		// Add
		function st_category_sidebar_field_add( $taxonomy ) {

			global
				$st_Options;

				$st_Settings = get_option( $st_Options['general']['name'] . 'settings' );
				$qty = !empty( $st_Settings['sidebar_qty'] ) ? $st_Settings['sidebar_qty'] : 0; ?>

				<div class="form-field term-parent-wrap">
					<label for="st_category_sidebar"><?php esc_attr_e( 'Sidebar', 'stkit' ); ?></label>
					<select class="postform" id="st_category_sidebar" name="st_category_sidebar">
						<option value="default-sidebar"><?php esc_attr_e( 'Default Sidebar', 'stkit' ) ?></option><?php
						if ( $qty > 0 ) {
							for ( $s = 0; $s <= $qty - 1; $s++ ) {
								echo '<option value="custom-bar-' . $s . '">' . ( !empty( $st_Settings['sidebar_labels'][$s] ) ? $st_Settings['sidebar_labels'][$s] : 'Custom bar ' . $s ) . '</option>';
							}
						} ?>
					</select>
					<p><?php esc_attr_e( 'Select one from the list.', 'stkit' ); ?></p>
				</div><?php

		}

		add_action( 'category_add_form_fields', 'st_category_sidebar_field_add', 10 );
		add_action( 'post_tag_add_form_fields', 'st_category_sidebar_field_add', 10 );

		// Edit
		function st_category_sidebar_field_edit( $tag, $taxonomy ) {

			global
				$st_Options;

				$st_Settings = get_option( $st_Options['general']['name'] . 'settings' );
				$qty = !empty( $st_Settings['sidebar_qty'] ) ? $st_Settings['sidebar_qty'] : 0;

				$st_['value'] = 'st_category_sidebar_' . $tag->term_id;
				$st_['st_category_sidebar'] = get_option( $st_['value'] );

				?>

					<tr class="form-field">
						<th scope="row" valign="top"><label for="st_category_sidebar"><?php esc_attr_e( 'Sidebar', 'stkit' ); ?></label></th>
						<td>
							<select class="postform" id="st_category_sidebar" name="st_category_sidebar">
								<option value="default-sidebar"><?php esc_attr_e( 'Default Sidebar', 'stkit' ) ?></option><?php
								if ( $qty > 0 ) {
									for ( $s = 0; $s <= $qty - 1; $s++ ) {
										$selected = $st_['st_category_sidebar'] == 'custom-bar-' . $s ? ' selected' : '';
										echo '<option value="custom-bar-' . $s . '"' . $selected . '>' . ( !empty( $st_Settings['sidebar_labels'][$s] ) ? $st_Settings['sidebar_labels'][$s] : 'Custom bar ' . $s ) . '</option>';
									}
								} ?>
							</select>
							<p class="description"><?php esc_attr_e( 'Select one from the list.', 'stkit' ); ?></p>
						</td>
					</tr>;

				<?php

		}

		add_action( 'category_edit_form_fields', 'st_category_sidebar_field_edit', 10, 2 );
		add_action( 'post_tag_edit_form_fields', 'st_category_sidebar_field_edit', 10, 2 );

		// Save
		function st_category_sidebar_field_save( $term_id ) {

			if ( isset( $_POST['st_category_sidebar'] ) ) {

				$st_['value'] = 'st_category_sidebar_' . $term_id;
				update_option( $st_['value'], $_POST['st_category_sidebar'] );

			}

		}

		add_action( 'created_category', 'st_category_sidebar_field_save', 10, 2 );
		add_action( 'edited_category', 'st_category_sidebar_field_save', 10, 2 );
		add_action( 'created_post_tag', 'st_category_sidebar_field_save', 10, 2 );
		add_action( 'edited_post_tag', 'st_category_sidebar_field_save', 10, 2 );

	}



	/*-------------------------------------------
		3.11 - Category sidebar 2
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['category-sidebar-2'] ) == true ) {

		// Add
		function st_category_sidebar_2_field_add( $taxonomy ) {

			global
				$st_Options;

				$st_Settings = get_option( $st_Options['general']['name'] . 'settings' );
				$qty = !empty( $st_Settings['sidebar_qty'] ) ? $st_Settings['sidebar_qty'] : 0; ?>

				<div class="form-field term-parent-wrap">
					<label for="st_category_sidebar_2"><?php esc_attr_e( 'Secondary Sidebar', 'stkit' ); ?></label>
					<select class="postform" id="st_category_sidebar_2" name="st_category_sidebar_2">
						<option value="secondary-sidebar"><?php esc_attr_e( 'Secondary Sidebar', 'stkit' ) ?></option><?php
						if ( $qty > 0 ) {
							for ( $s = 0; $s <= $qty - 1; $s++ ) {
								echo '<option value="custom-bar-' . $s . '">' . ( !empty( $st_Settings['sidebar_labels'][$s] ) ? $st_Settings['sidebar_labels'][$s] : 'Custom bar ' . $s ) . '</option>';
							}
						} ?>
					</select>
					<p><?php esc_attr_e( 'Select one from the list.', 'stkit' ); ?></p>
				</div><?php

		}

		add_action( 'category_add_form_fields', 'st_category_sidebar_2_field_add', 10 );
		add_action( 'post_tag_add_form_fields', 'st_category_sidebar_2_field_add', 10 );

		// Edit
		function st_category_sidebar_2_field_edit( $tag, $taxonomy ) {

			global
				$st_Options;

				$st_Settings = get_option( $st_Options['general']['name'] . 'settings' );
				$qty = !empty( $st_Settings['sidebar_qty'] ) ? $st_Settings['sidebar_qty'] : 0;

				$st_['value'] = 'st_category_sidebar_2_' . $tag->term_id;
				$st_['st_category_sidebar_2'] = get_option( $st_['value'] );

				?>

					<tr class="form-field">
						<th scope="row" valign="top"><label for="st_category_sidebar_2"><?php esc_attr_e( 'Secondary Sidebar', 'stkit' ); ?></label></th>
						<td>
							<select class="postform" id="st_category_sidebar_2" name="st_category_sidebar_2">
								<option value="secondary-sidebar"><?php esc_attr_e( 'Secondary Sidebar', 'stkit' ) ?></option><?php
								if ( $qty > 0 ) {
									for ( $s = 0; $s <= $qty - 1; $s++ ) {
										$selected = $st_['st_category_sidebar_2'] == 'custom-bar-' . $s ? ' selected' : '';
										echo '<option value="custom-bar-' . $s . '"' . $selected . '>' . ( !empty( $st_Settings['sidebar_labels'][$s] ) ? $st_Settings['sidebar_labels'][$s] : 'Custom bar ' . $s ) . '</option>';
									}
								} ?>
							</select>
							<p class="description"><?php esc_attr_e( 'Select one from the list.', 'stkit' ); ?></p>
						</td>
					</tr>;

				<?php

		}

		add_action( 'category_edit_form_fields', 'st_category_sidebar_2_field_edit', 10, 2 );
		add_action( 'post_tag_edit_form_fields', 'st_category_sidebar_2_field_edit', 10, 2 );

		// Save
		function st_category_sidebar_2_field_save( $term_id ) {

			if ( isset( $_POST['st_category_sidebar_2'] ) ) {

				$st_['value'] = 'st_category_sidebar_2_' . $term_id;
				update_option( $st_['value'], $_POST['st_category_sidebar_2'] );

			}

		}

		add_action( 'created_category', 'st_category_sidebar_2_field_save', 10, 2 );
		add_action( 'edited_category', 'st_category_sidebar_2_field_save', 10, 2 );
		add_action( 'created_post_tag', 'st_category_sidebar_2_field_save', 10, 2 );
		add_action( 'edited_post_tag', 'st_category_sidebar_2_field_save', 10, 2 );

	}



	/*-------------------------------------------
		3.12 - Category sidebar position
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['category-sidebar-position'] ) == true ) {

		// Add
		function st_category_sidebar_position_field_add( $taxonomy ) {

			global
				$st_Options; ?>

				<div class="form-field term-parent-wrap">
					<label for="st_category_sidebar_2"><?php esc_attr_e( 'Sidebar position', 'stkit' ); ?></label>
					<?php

						$st_['array'] = array('left','none','right');

						foreach ( $st_['array'] as $key ) {

							$st_['checked'] = '';

							// Select the First
							if ( $key == $st_Options['panel']['major']['sidebar']['position']['default'] )
								$st_['checked'] = 'checked="checked"';

							// Select requred scheme
							if ( !empty( $st_['st_category_sidebar_position'] ) && $st_['st_category_sidebar_position'] == $key )
								$st_['checked'] = 'checked="checked"'; ?>

							<div class="tmpl_radio">
								<label class="lable-img" for="st_category_sidebar_position_<?php echo $key ?>">
									<img src="<?php echo plugins_url() ?>/stkit/components/metaboxes/assets/images/schemes/<?php echo $key ?>.png" width="50" height="40">
								</label>
								<input type="radio" name="st_category_sidebar_position" value="<?php echo $key ?>" id="st_category_sidebar_position_<?php echo $key ?>" <?php echo $st_['checked'] ?> />
							</div><?php

						}

					?>
					<div class="clear"><!-- clear --></div>
					<p class="description"><?php esc_attr_e(' Select the default position of sidebar.', 'stkit' ) ?></p>
				</div><?php

		}

		add_action( 'category_add_form_fields', 'st_category_sidebar_position_field_add', 10 );
		add_action( 'post_tag_add_form_fields', 'st_category_sidebar_position_field_add', 10 );

		// Edit
		function st_category_sidebar_position_field_edit( $tag, $taxonomy ) {

			global
				$st_Options;

				$st_['value'] = 'st_category_sidebar_position_' . $tag->term_id;
				$st_['st_category_sidebar_position'] = get_option( $st_['value'] );

				?>

					<tr class="form-field">
						<th scope="row" valign="top"><label for="st_category_sidebar_position"><?php esc_attr_e( 'Sidebar position', 'stkit' ); ?></label></th>
						<td>
							<?php

								$st_['array'] = array('left','none','right');

								foreach ( $st_['array'] as $key ) {

									$st_['checked'] = '';

									// Select the First in case database is empty
									if ( !$st_['st_category_sidebar_position'] && $key == $st_Options['panel']['major']['sidebar']['position']['default'] )
										$st_['checked'] = 'checked="checked"';

									// Select requred scheme
									if ( !empty( $st_['st_category_sidebar_position'] ) && $st_['st_category_sidebar_position'] == $key )
										$st_['checked'] = 'checked="checked"'; ?>

									<div class="tmpl_radio">
										<label class="lable-img" for="st_category_sidebar_position_<?php echo $key ?>">
											<img src="<?php echo plugins_url() ?>/stkit/components/metaboxes/assets/images/schemes/<?php echo $key ?>.png" width="50" height="40">
										</label>
										<input type="radio" name="st_category_sidebar_position" value="<?php echo $key ?>" id="st_category_sidebar_position_<?php echo $key ?>" <?php echo $st_['checked'] ?> />
									</div><?php

								}

							?>
							<div class="clear"><!-- clear --></div>
							<p class="description"><?php esc_attr_e(' Select the default position of sidebar.', 'stkit' ) ?></p>
						</td>
					</tr>;

				<?php

		}

		add_action( 'category_edit_form_fields', 'st_category_sidebar_position_field_edit', 10, 2 );
		add_action( 'post_tag_edit_form_fields', 'st_category_sidebar_position_field_edit', 10, 2 );

		// Save
		function st_category_sidebar_position_field_save( $term_id ) {

			if ( isset( $_POST['st_category_sidebar_position'] ) ) {

				$st_['value'] = 'st_category_sidebar_position_' . $term_id;
				update_option( $st_['value'], $_POST['st_category_sidebar_position'] );

			}

		}

		add_action( 'created_category', 'st_category_sidebar_position_field_save', 10, 2 );
		add_action( 'edited_category', 'st_category_sidebar_position_field_save', 10, 2 );
		add_action( 'created_post_tag', 'st_category_sidebar_position_field_save', 10, 2 );
		add_action( 'edited_post_tag', 'st_category_sidebar_position_field_save', 10, 2 );

	}



	/*-------------------------------------------
		3.13 - Category blogroll
	-------------------------------------------*/

	if ( !empty( $st_Options['global']['category-blogroll'] ) == true ) {

		// Add
		function st_category_blogroll_field_add( $taxonomy ) {

			global
				$st_Options; ?>

				<div class="form-field term-parent-wrap">
					<label for="st_category_sidebar_2"><?php esc_attr_e( 'Blogroll template', 'stkit' ); ?></label>
					<?php
						foreach ( $st_Options['panel']['major']['blog']['template'] as $st_['template'] => $key ) {

							if ( $key['status']  ) {

								$st_['checked'] = '';

								// Select the Default in case database is empty
								if ( !$st_['template'] || $st_['template'] == 'default' )
									$st_['checked'] = 'checked="checked"';

								// Select requred template
								if ( !empty( $st_['st_category_blogroll'] ) && $st_['st_category_blogroll'] == $st_['template'] )
									$st_['checked'] = 'checked="checked"'; ?>

								<div class="tmpl_radio">
									<label class="lable-img" for="<?php echo $st_['template'] ?>_template">
										<img class="tooltip" src="<?php echo plugins_url() ?>/stkit/assets/images/schemes/posts/<?php echo $key['label'] ?>.gif" width="80" height="60" title="<?php echo $key['desc'] ?>">
									</label>
									<input type="radio" value="<?php echo esc_html( $st_['template'] ) ?>" name="st_category_blogroll" id="<?php echo $st_['template'] ?>_template" <?php echo $st_['checked'] ?> />
								</div>
								<?php

							}

						}
					?>
					<div class="clear"><!-- clear --></div>
					<p class="description"><?php esc_attr_e( 'Select blogroll template.', 'stkit' ); ?></p>
				</div><?php

		}

		add_action( 'category_add_form_fields', 'st_category_blogroll_field_add', 10 );
		add_action( 'post_tag_add_form_fields', 'st_category_blogroll_field_add', 10 );

		// Edit
		function st_category_blogroll_field_edit( $tag, $taxonomy ) {

			global
				$st_Options;

				$st_['value'] = 'st_category_blogroll_' . $tag->term_id;
				$st_['st_category_blogroll'] = get_option( $st_['value'] );

				?>

					<tr class="form-field">
						<th scope="row" valign="top"><label for="st_category_blogroll"><?php esc_attr_e( 'Blogroll template', 'stkit' ); ?></label></th>
						<td>
							<?php
								foreach ( $st_Options['panel']['major']['blog']['template'] as $st_['template'] => $key ) {

									if ( $key['status']  ) {

										$st_['checked'] = '';

										// Select the Default in case database is empty
										if ( !$st_['template'] || $st_['template'] == 'default' )
											$st_['checked'] = 'checked="checked"';

										// Select requred template
										if ( !empty( $st_['st_category_blogroll'] ) && $st_['st_category_blogroll'] == $st_['template'] )
											$st_['checked'] = 'checked="checked"'; ?>

										<div class="tmpl_radio">
											<label class="lable-img" for="<?php echo $st_['template'] ?>_template">
												<img class="tooltip" src="<?php echo plugins_url() ?>/stkit/assets/images/schemes/posts/<?php echo $key['label'] ?>.gif" width="80" height="60" title="<?php echo $key['desc'] ?>">
											</label>
											<input type="radio" value="<?php echo esc_html( $st_['template'] ) ?>" name="st_category_blogroll" id="<?php echo $st_['template'] ?>_template" <?php echo $st_['checked'] ?> />
											<label for="<?php echo $st_['template'] ?>_template"><?php echo $key['label'] ?></label>
										</div><?php

									}

								}
							?>
						</td>
					</tr>;

				<?php

		}

		add_action( 'category_edit_form_fields', 'st_category_blogroll_field_edit', 10, 2 );
		add_action( 'post_tag_edit_form_fields', 'st_category_blogroll_field_edit', 10, 2 );

		// Save
		function st_category_blogroll_field_save( $term_id ) {

			if ( isset( $_POST['st_category_blogroll'] ) ) {

				$st_['value'] = 'st_category_blogroll_' . $term_id;
				update_option( $st_['value'], $_POST['st_category_blogroll'] );

			}

		}

		add_action( 'created_category', 'st_category_blogroll_field_save', 10, 2 );
		add_action( 'edited_category', 'st_category_blogroll_field_save', 10, 2 );
		add_action( 'created_post_tag', 'st_category_blogroll_field_save', 10, 2 );
		add_action( 'edited_post_tag', 'st_category_blogroll_field_save', 10, 2 );

	}




/*= 4 ===========================================

	F U N C T I O N S
	Permanent custom functions

===============================================*/


	/*-------------------------------------------
		4.1 - Post views
	-------------------------------------------*/

	if ( !empty( $st_Settings['post_views'] ) && $st_Settings['post_views'] == 'yes' ) {

		// Display views
		function st_getPostViews( $postID ) {

			$count_key = 'post_views_count';
			$count = get_post_meta($postID, $count_key, true);

			if ( $count == '' ) {

				delete_post_meta( $postID, $count_key );
				add_post_meta( $postID, $count_key, '0' );

				return '';

			}

			return number_format( $count );

		}

		// Count views
		function st_setPostViews( $postID ) {

			$count_key = 'post_views_count';
			$count = get_post_meta( $postID, $count_key, true );

			if ( $count == '' ) {

				$count = 0;

				delete_post_meta( $postID, $count_key );
				add_post_meta( $postID, $count_key, '0' );

			} else {

				$count++;

				update_post_meta( $postID, $count_key, $count );

			}

		}

	}



	/*-------------------------------------------
		4.2 - Nice time
	-------------------------------------------*/

	if ( !empty( $st_Settings['nice_time'] ) && $st_Settings['nice_time'] == 'yes' ) {

		function st_niceTime( $time ) {

			$time = strtotime( str_replace( '+0000', '', $time ) );

			$delta = time() - $time;

			switch ( $delta ) {

				case ( $delta < 60  ) : return esc_attr__( 'less than 1 minute ago', 'stkit' );
				case ( $delta < 120 ) : return esc_attr__( '1 minute ago', 'stkit' );

				case ( $delta < ( 60  * 60 ) ) : return sprintf( esc_attr__( '%d minutes ago', 'stkit' ), floor( $delta / 60 ) );
				case ( $delta < ( 120 * 60 ) ) : return esc_attr__( '1 hour ago', 'stkit' );

				case ( $delta < ( 24 * 60 * 60 ) ) : return sprintf( esc_attr__( '%d hours ago', 'stkit' ), floor( $delta / 3600 ) );
				case ( $delta < ( 48 * 60 * 60 ) ) : return esc_attr__( '1 day ago', 'stkit' );

				case ( $delta < ( 30 * 24 * 60 * 60 ) ) : return sprintf( esc_attr__( '%d days ago', 'stkit' ), floor( $delta / 86400 ) );
				case ( $delta < ( 60 * 24 * 60 * 60 ) ) : return esc_attr__( '1 month ago', 'stkit' );

				case ( $delta < ( 12 * 30 * 24 * 60 * 60 ) ) : return sprintf( esc_attr__( '%d months ago', 'stkit' ), floor( $delta / 2592000 ) );
				case ( $delta < ( 24 * 30 * 24 * 60 * 60 ) ) : return esc_attr__( '1 year ago', 'stkit' );

				case ( $delta < ( 100 * 12 * 30 * 24 * 60 * 60 ) ) : return sprintf( esc_attr__( '%d years ago', 'stkit' ), floor( $delta / 31104000 ) );

				default :

					if ( ( $delta / 86400 ) < 3650 )
						return sprintf( esc_attr__( '%d days ago', 'stkit' ), floor( $delta / 86400 ) );
					else
						return '&mdash;';

			}

		}

	}



	/*-------------------------------------------
		4.3 - Icons the Social
	-------------------------------------------*/

	if ( !empty( $st_Settings['lifestream'] ) && $st_Settings['lifestream'] == 'yes' || !empty($st_Options['widgets']['social-icons']) ) {

		function st_icons_social( $id = true, $tooltip = true, $class = 'tooltip', $attribute = 'title' ) {

			global
				$st_Options,
				$st_Settings;

				$out = '<div class="icons-social">';

					// Icons selected
					foreach ( $st_Options['networks'] as $value ) {
						if ( $st_Settings[$value] ) {

							$value = substr( $value, 5 );

							if ( $id == true ) {

								$attr = 'id="icon-' . $value . '"' . ( $tooltip == true ? ' class="' . $class . '"' : '' );

							}

							else {

								$attr = 'class="st-icon-' . $value . ( $tooltip == true ? ' ' . $class . '"' : '"' );

							}

							$out .= "\n";
							$out .= '<a ' . $attr . ' ' . $attribute . '="' . $value . '" href="' . st_get_redirect_page_url() . esc_url( $st_Settings['life_' . $value] ) . '" target="_blank"><!-- --></a>';

						}
					}

					// Icons custom
					if ( !empty( $st_Settings['lifestream_custom'] ) && $st_Settings['lifestream_custom'] )
						$out .= !empty( $st_Settings['sanitization'] ) && $st_Settings['sanitization'] == 'no' ? do_shortcode( $st_Settings['lifestream_custom'] ) : esc_attr( $st_Settings['lifestream_custom'] );

				$out .= '</div>';

				echo $out;

			return;

		}

	}



	/*-------------------------------------------
		4.4 - Path of custom.css file
	-------------------------------------------*/

	function st_get_custom_css( $type ) {

		global
			$st_Options;

			$upload = wp_upload_dir();

			if ( $type == 'path' )
				$path = $upload['basedir'] . '/' . $st_Options['general']['name'] . 'custom.css';

			if ( $type == 'url' )
				$path = set_url_scheme( $upload['baseurl'] . '/' . $st_Options['general']['name'] . 'custom.css' );

		return $path;

	}



	/*-------------------------------------------
		4.5 - Get a first image from post
	-------------------------------------------*/

	function st_get_first_image( $id = 0 ) {

		if ( $id == 0 )
			global $post;

		else
			$post = get_post( $id );

			$src = '';

			ob_start();

			ob_end_clean();

			$output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches );

			if ( $matches[1] )
				$src = $matches[1][0] ? $matches[1][0] : '';

		return
			$src;

	}



	/*-------------------------------------------
		4.6 - Write Custom CSS
	-------------------------------------------*/

	function st_custom_css() {

		include ( plugin_dir_path( __FILE__ ) . '/write-custom-css.php' );

	}



	/*-------------------------------------------
		4.7 - Get 2x image URL
	-------------------------------------------*/

	function st_get_2x( $post_id, $image, $output = 'array', $class = '' ) {

		global
			$st_Options,
			$st_Settings;

			if ( $st_Options['panel']['misc']['hidpi'] && !isset( $st_Settings['hidpi'] ) || !empty( $st_Settings['hidpi'] ) != 'no' ) {

				$image2x = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), $image . '-2x' );

				if ( $image2x ) {

					if ( $output == 'array' )
						return array( 'data-hidpi' => $image2x[0], 'class' => $class );

					if ( $output == 'url' )
						return $image2x[0];

					if ( $output == 'attr' )
						return 'data-hidpi="' . $image2x[0] . '"';

				}

				else
					return;

			}

			else
				return;

	}



	/*-------------------------------------------
		4.8 - Get post format icon
	-------------------------------------------*/

	function st_get_format_icon( $post_id, $size = 16, $class = '', $color = 'white', $return = 'image' ) {

		global
			$st_Options,
			$st_Settings;

			$output = '';

			// Post type names
			$st_['st_post'] = !empty( $st_Settings['ctp_post'] ) ? $st_Settings['ctp_post'] : $st_Options['ctp']['post'];

			// Project format
			if ( get_post_type( $post_id ) == $st_['st_post'] ) {
				$format = st_get_post_meta( $post_id, 'format_value', true, 'gallery' ); }

			// Post format
			else {
				$format = ( get_post_format( $post_id ) && $st_Options['global']['post-formats'][get_post_format( $post_id )]['status'] ) ? get_post_format( $post_id ) : 'standard'; }

			$icons = array(
				'standard'	=> 'file-2',
				'image'		=> 'image',
				'gallery'	=> 'gallery',
				'audio'		=> 'audio',
				'video'		=> 'video',
				'link'		=> 'link',
				'quote'		=> 'quote',
				'status'	=> 'user'
			);

			foreach ( $icons as $key => $icon ) {
				if ( $format == $key ) {

					if ( $return == 'image' ) {

						$src = plugins_url() . '/stkit/assets/images/icons/' . $size . '/glyphs/' . $color . '/' . $icon . '.png';

						if ( $st_Options['panel']['misc']['hidpi'] && !isset( $st_Settings['hidpi'] ) || !empty( $st_Settings['hidpi'] ) != 'no' )
							$hidpi = 'data-hidpi="' . plugins_url() . '/stkit/assets/images/icons/' . $size * 2 . '/glyphs/' . $color . '/' . $icon . '.png"';
						else
							$hidpi = '';

						$output = '<img src="' . $src . '" width="' . $size . '" height="' . $size . '" ' . $hidpi . ' class="' . $class . '" alt="" />';

					}

					elseif ( $return == 'text' ) {

						$output = $icon;

					}

				}
			}

			return $output;

	}



	/*-------------------------------------------
		4.9 - Custom Background Callback
	-------------------------------------------*/

	function st_custom_background_cb() {

		global
			$st_,
			//$birdhouse_;
			$st_Kit,
			${ $st_Kit['theme_name'] . '_' };


			//if ( !empty( $birdhouse_ ) )
			//	$st_ = $birdhouse_;
			if ( !empty( ${ $st_Kit['theme_name'] . '_' } ) )
				$st_ = ${ $st_Kit['theme_name'] . '_' };

		if ( is_single() ) {

			global
				$post;

				$st_['bg-image'] = wp_get_attachment_image_src( st_get_post_meta( $post->ID, 'bg-image_value', true, 0 ), 'full' );
				$st_['bg-color'] = st_get_post_meta( $post->ID, 'bg-color_value', true, false );

		}

		$background = !empty( $st_['bg-image'][0] ) ? $st_['bg-image'][0] : set_url_scheme( get_background_image() );

		$color = !empty( $st_['bg-color'] ) && $st_['bg-image'][0] ? $st_['bg-color'] : get_theme_mod( 'background_color' );

		if ( ! $background && ! $color ) {
			return; }

		$style = $color ? "background-color: #$color;" : '';

		if ( $background ) {

			$image = " background-image: url('$background');";


			$repeat = get_theme_mod( 'background_repeat', 'no-repeat' );

			if ( ! in_array( $repeat, array( 'no-repeat', 'repeat-x', 'repeat-y', 'repeat' ) ) ) {
				$repeat = 'no-repeat';
			}
			$repeat = " background-repeat: $repeat;";


			$position = get_theme_mod( 'background_position_x', 'center' );

			if ( ! in_array( $position, array( 'center', 'right', 'left' ) ) ) {
				$position = 'center';
			}
			$position = " background-position: top $position;";


			$attachment = get_theme_mod( 'background_attachment', 'fixed' );

			if ( ! in_array( $attachment, array( 'fixed', 'scroll' ) ) ) {
				$attachment = 'fixed';
			}
			$attachment = " background-attachment: $attachment;";


			$style .= $image . $repeat . $position . $attachment;

		}

		echo '<style type="text/css" id="custom-background-css">body.custom-background { ' . trim( $style ) . ' }</style>' . "\n";

	}



	/*-------------------------------------------
		4.10 - Adjust Color Brightness
	-------------------------------------------*/

	function st_adjustBrightness( $hex, $steps ) {

		// Steps should be between -255 and 255. Negative = darker, positive = lighter
		$steps = max( -255, min( 255, $steps ) );

		// Format the hex color string
		$hex = str_replace( '#', '', $hex );

		if ( strlen($hex) == 3 )
			$hex = str_repeat( substr( $hex, 0, 1 ), 2 ).str_repeat( substr( $hex, 1, 1 ), 2 ).str_repeat( substr( $hex, 2, 1 ), 2 );

		// Get decimal values
		$r = hexdec( substr( $hex, 0, 2 ) );
		$g = hexdec( substr( $hex, 2, 2 ) );
		$b = hexdec( substr( $hex, 4, 2 ) );

		// Adjust number of steps and keep it inside 0 to 255
		$r = max( 0, min( 255, $r + $steps ) );
		$g = max( 0, min( 255, $g + $steps ) );
		$b = max( 0, min( 255, $b + $steps ) );

		$r_hex = str_pad( dechex($r), 2, '0', STR_PAD_LEFT );
		$g_hex = str_pad( dechex($g), 2, '0', STR_PAD_LEFT );
		$b_hex = str_pad( dechex($b), 2, '0', STR_PAD_LEFT );

		return $r_hex . $g_hex . $b_hex;

	}



	/*-------------------------------------------
		4.11 - Related posts
	-------------------------------------------*/

	function st_kit_related_posts( $qty = 4, $title = '', $h = 'h6', $image_size = 'project-thumb', $class = 'posts-related-wrapper', $date = false, $query = false ) {

		global
			$post,
			$st_Settings,
			$st_,
			//$birdhouse_;
			$st_Kit,
			${ $st_Kit['theme_name'] . '_' };

			//if ( !empty( $birdhouse_ ) )
			//	$st_ = $birdhouse_;
			if ( !empty( ${ $st_Kit['theme_name'] . '_' } ) )
				$st_ = ${ $st_Kit['theme_name'] . '_' };

			$st_['args'] = array();
			$st_['postcount'] = 0;
			$st_['out'] = '';
			$st_['timeframe'] = !empty( $st_Settings['related_posts_period'] ) ? $st_Settings['related_posts_period'] : 'all';

			// if standard post (for non-CTP)
			if ( get_post_type( $post->ID ) == 'post' ) {

				// get post tags
				$st_['tags'] = array();
				$st_['arr'] = wp_get_post_tags( $post->ID );

				foreach ( $st_['arr'] as $st_['tag'] => $st_['key'] )
					$st_['tags'][] = $st_['key']->term_id;

				// by tags
				$st_['args'] = array(
					'post_type'				=>	'post',
					'posts_per_page'		=>	$qty,
					'order'					=>	'DESC',
					'orderby'				=>	'rand',
					'paged'					=>	1,
					'post_status'			=>	'publish',
					'post__not_in'			=>	array( $post->ID ),
					'ignore_sticky_posts'	=>	1,
					'tag__in'				=>	$st_['tags'],
					'date_query'			=> ( $st_['timeframe'] != 'all' ?
														array(
															array(
																'column'	=> 'post_date_gmt',
																'after'		=> '1 ' . $st_['timeframe'] . ' ago',
															),
														)
												: '' ),
				);

				// get the query
				$st_query = get_transient( 'st_related_posts_' . $post->ID );

				if ( $st_query == false ) {

					$st_query = new WP_Query( $st_['args'] );
					wp_reset_postdata();

					set_transient( 'st_related_posts_' . $post->ID, $st_query, 60 * 60 );

				}

				// if query result is false -> get a posts by category
				if ( $st_query->found_posts == 0 ) {

					$st_['args'] = array(
						'post_type'				=>	'post',
						'posts_per_page'		=>	$qty,
						'order'					=>	'DESC',
						'orderby'				=>	'rand',
						'paged'					=>	1,
						'post_status'			=>	'publish',
						'post__not_in'			=>	array( $post->ID ),
						'ignore_sticky_posts'	=>	1,
						'category__in'			=>	wp_get_post_categories( $post->ID ),
						'date_query'			=> ( $st_['timeframe'] != 'all' ?
															array(
																array(
																	'column'	=> 'post_date_gmt',
																	'after'		=> '1 ' . $st_['timeframe'] . ' ago',
																),
															)
													: '' ),
					);

					// re-get the query
					$st_query = new WP_Query( $st_['args'] );
					wp_reset_postdata();

					set_transient( 'st_related_posts_' . $post->ID, $st_query, 60 * 60 );

				}

				// Posts found
				//$st_['posts_found'] = $st_['sidebar_position'] == 'none' ? 'full' : count( $st_query->posts );
				$st_['posts_found'] = count( $st_query->posts );
				$st_['posts_found_class_part'] = $st_['sidebar_position'] == 'none' ? 'full' : count( $st_query->posts );

				// Return array
				if ( $query == true ) {

					wp_reset_postdata();
					return $st_query;

				}

				while ( $st_query->have_posts() ) : $st_query->the_post();

					// Post format
					$st_['format'] = get_post_format( $post->ID ) ? get_post_format( $post->ID ) : 'standard';

					$st_['postcount']++;


					// Feat image
					if ( has_post_thumbnail() ) {

						$st_['id'] = get_post_thumbnail_id( $post->ID );
						$st_['thumb'] = wp_get_attachment_image_src( $st_['id'], $image_size );
						$st_['thumb'] = $st_['thumb'][0];

					}

					else {

						$st_['thumb'] = get_template_directory_uri() . '/assets/images/placeholder.png';

					}


					// Compose post
					$st_['out'] .= '<td class="posts-related-post-td-' . $st_['postcount'] . '"><div class="posts-related-post-wrapper' . ( $st_['postcount'] == 1 && $st_['posts_found'] > 2 ? ' first' : ( $st_['postcount'] == $st_['posts_found'] && $st_['posts_found'] > 2 ? ' last' : '' ) )  . '">';

						// Compose thumb
						$st_['out'] .= '<a href="' . get_permalink() . '" class="post-thumb post-thumb-' . $st_['format'] . '" ' . ( function_exists( 'st_get_2x' ) ? st_get_2x( $post->ID, $image_size, 'attr' ) : '' ) . ' style="background-image: url(' . $st_['thumb'] . ')" data-format="' . $st_['format'] . '">&nbsp;</a>';

						// Other
						$st_['out'] .= '<div class="posts-related-details-wrapper"><div>' .

							'<h5><a href="' . get_permalink() . '">' . get_the_title() . '</a></h5>' .

							( $date ? '<div class="meta"><span class="ico16 ico16-calendar">' . ( !empty( $st_Settings['nice_time'] ) && $st_Settings['nice_time'] == 'yes' && function_exists( 'st_niceTime' ) ? st_niceTime( $post->post_date_gmt ) : get_the_time( get_option('date_format'), $post->ID ) ) . '</span></div>' : '' );

						$st_['out'] .= '</div></div>';

					$st_['out'] .= '</div></td>' . "\n";


				endwhile;

				wp_reset_postdata();


				// Out
				if ( $st_['out'] ) {

					$title = $title ? "\n<" . $h . ">" . $title . "</" . $h . ">\n" : '';

					return '<div class="' . $class . ' posts-related-' . $st_['posts_found_class_part'] . '-wrapper posts-related-' . $st_['posts_found'] . '-wrapper">' . $title . '<table><tbody><tr>' . $st_['out'] . '</tr></tbody></table><div class="clear"><!-- --></div></div>';

				}
				else
					return;


			}

	}



	/*-------------------------------------------
		4.12 - Get authors by post count
	-------------------------------------------*/

	function st_get_authors_by_post_count( $post_type = 'post' ) {

		global
			$wpdb;

			$post_type = str_replace( array( '$', '%', '#', '<', '>', '|' ), '', $post_type );

			$posts = $wpdb->prefix . 'posts';
			$users = $wpdb->base_prefix . 'users';

			$st_['query'] = "
				SELECT ID, user_email, post_count
				FROM $users
					LEFT OUTER JOIN (
						SELECT post_author, COUNT(*) as post_count
						FROM $posts
						WHERE post_type = '$post_type' AND post_status = 'publish'
						GROUP BY post_author
					)
				p ON ( $users.ID = p.post_author )
				WHERE post_count > 0
				ORDER BY post_count DESC";

		return $wpdb->get_results( $st_['query'] );

	}



	/*-------------------------------------------
		4.13 - Post social share
	-------------------------------------------*/

	function st_post_share( $attr ) {

		if ( !is_array( $attr ) ) // Support for outdated usage
			$attr = array( 'id' => $attr );

		$st_['arr'] = array(
			'id'		=> 1,
			'gp'		=> true,
			'fb'		=> true,
			'tw'		=> true,
			'dg'		=> true,
			'dl'		=> true,
			'st'		=> true,
			'ln'		=> true,
			'pn' 		=> true,
			'class'		=> 'tooltip',
			'attribute'	=> 'title'
		);

		foreach ( $attr as $key => $value ) {
			if ( isset( $attr[$key] ) )
				$st_['arr'][$key] = $value;
		}

		global
			$st_Options;

			$prefix = !empty( $st_Options['general']['prefix'] ) ? $st_Options['general']['prefix'] : 'st-';

		$out = '<div class="st-post-share"><div>' . "\n";

			// Google+
			if ( $st_['arr']['gp'] ) $out .= '<a class="st-ps-gp ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://plus.google.com/share?url=' . get_permalink( $st_['arr']['id'] ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Google+', 'stkit' ) . '"><!-- Google+ --></a>';

			// Facebook
			if ( $st_['arr']['fb'] ) $out .= '<a class="st-ps-fb ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://www.facebook.com/sharer/sharer.php?u=' . get_permalink( $st_['arr']['id'] ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Facebook', 'stkit' ) . '"><!-- Facebook --></a>';

			// Twitter
			if ( $st_['arr']['tw'] ) $out .= '<a class="st-ps-tw ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://twitter.com/home?status=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '%20-%20' . get_permalink( $st_['arr']['id'] ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Twitter', 'stkit' ) . '"><!-- Twitter --></a>';

			// Digg
			if ( $st_['arr']['dg'] ) $out .= '<a class="st-ps-dg ' . $st_['arr']['class'] . ' no-auto-lightbox" href="http://digg.com/submit?url=' . get_permalink( $st_['arr']['id'] ) . '&amp;title=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Digg', 'stkit' ) . '"><!-- Digg --></a>';

			// Delicious
			if ( $st_['arr']['dl'] ) $out .= '<a class="st-ps-dl ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://delicious.com/save?url=' . get_permalink( $st_['arr']['id'] ) . '&amp;title=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Delicious', 'stkit' ) . '"><!-- Delicious --></a>';

			// Stumbleupon
			if ( $st_['arr']['st'] ) $out .= '<a class="st-ps-st ' . $st_['arr']['class'] . ' no-auto-lightbox" href="http://www.stumbleupon.com/submit?url=' . get_permalink( $st_['arr']['id'] ) . '&amp;title=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Stumbleupon', 'stkit' ) . '"><!-- Stumbleupon --></a>';

			// LinkedIn
			if ( $st_['arr']['ln'] ) $out .= '<a class="st-ps-ln ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://www.linkedin.com/shareArticle?mini=true&amp;url=' . get_permalink( $st_['arr']['id'] ) . '&amp;title=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on LinkedIn', 'stkit' ) . '"><!-- LinkedIn --></a>';

			// Pinterest
			if ( $st_['arr']['pn'] && has_post_thumbnail( $st_['arr']['id'] ) ) {

				$img = wp_get_attachment_image_src( get_post_thumbnail_id( $st_['arr']['id'] ), ( !empty( $st_Options['global']['images']['large'] ) ? 'large' : $prefix . 'large' ) ); // st-thumbnail since v.1.7.6

				$out .= '<a class="st-ps-pn ' . $st_['arr']['class'] . ' no-auto-lightbox" href="https://pinterest.com/pin/create/button/?url=' . get_permalink( $st_['arr']['id'] ) . '&amp;media=' . $img[0] . '&amp;description=' . str_replace( ' ', '%20', get_the_title( $st_['arr']['id'] ) ) . '" target="_blank" ' . $st_['arr']['attribute'] . '="' . esc_attr__( 'Share on Pinterest', 'stkit' ) . '"><!-- Pinterest --></a>';

			}

		$out .= '</div></div>';

		return $out;

	}



	/*-------------------------------------------
		4.14 - ST Kit allowed tags
	-------------------------------------------*/

	// Used on st_admin.php:561
	function st_tags_allowed( $tag_excepted ) {

		global
			$st_Kit;

			unset( $st_Kit['tags_allowed'][$tag_excepted] );

		return
			$st_Kit['tags_allowed'];

	}



	/*-------------------------------------------
		4.15 - schema.org itemscope
	-------------------------------------------*/

	function st_schema_org_article_itemscope( $args ) {

		global
			$post,
			$st_Settings;

			if ( empty( $post ) ) return;

			$st_['logo'] = !empty( $st_Settings['logo'] ) ? $st_Settings['logo'] : get_template_directory_uri() . '/assets/images/logo.png';

			$schema = '<meta itemprop="datePublished" content="' . get_the_time( 'c', $post->ID ). '">';
			$schema .= '<meta itemprop="dateModified" content="' . get_the_modified_time( 'c' ). '">';
			$schema .= '<meta itemprop="mainEntityOfPage" itemscope content itemType="https://schema.org/WebPage" itemid="' . get_the_permalink( $post->ID ) . '"/>';
			$schema .= '<meta itemprop="headline" content="' . get_bloginfo( 'description' ) . '">';
			if ( is_object( get_userdata( $post->post_author ) ) )
				$schema .= '<span itemprop="author" itemscope itemtype="https://schema.org/Person" class="none"><meta itemprop="name" content="' . get_userdata( $post->post_author )->display_name . '"></span>';
			$schema .= '<span itemprop="publisher" itemscope itemtype="https://schema.org/Organization" class="none">';

				$schema .= '<span itemprop="logo" itemscope itemtype="https://schema.org/ImageObject">';
					$schema .= '<meta itemprop="url" content="' . $st_['logo'] . '">';
				$schema .= '</span>';
				$schema .= '<meta itemprop="name" content="' . get_bloginfo( 'name' ) . '">';
			$schema .= '</span>';

			if ( has_post_thumbnail( $post->ID ) ) {


				$st_['id'] = get_post_thumbnail_id( $post->ID );
				$st_['thumb'] = wp_get_attachment_image_src( $st_['id'], 'full' );

				$schema .= '<span class="none" itemprop="image" itemscope itemtype="https://schema.org/ImageObject">';
					$schema .= '<meta itemprop="url" content="' . $st_['thumb'][0] . '">';
					$schema .= '<meta itemprop="width" content="' . $st_['thumb'][1] . '">';
					$schema .= '<meta itemprop="height" content="' . $st_['thumb'][2] . '">';
				$schema .= '</span>';

			}

		return $schema;

	}

	function st_schema_org_review_itemscope( $args ) {

		global
			$post;

			if ( empty( $post ) ) return;

			if ( function_exists( 'wp_review_show_total' ) && get_post_meta( $post->ID, 'wp_review_total', true ) ) {

				$st_['type'] = get_post_meta( $post->ID, 'wp_review_type', true );
				$st_['total'] = get_post_meta( $post->ID, 'wp_review_total', true );
				$st_['max'] = 5; // Stars
				$st_['max'] = $st_['type'] == 'point' ? 10 : $st_['max']; // Points
				$st_['max'] = $st_['type'] == 'percentage' ? 100 : $st_['max']; // Percentage

				$schema =
					'<meta itemprop="itemReviewed" content = "' . strip_tags( $post->post_title, '' ) . '">' .
					'<meta itemprop="about" content = "' . strip_tags( get_post_meta( $post->ID, 'wp_review_desc', true ), '' ) . '">' .
					'<span itemprop="reviewRating" itemscope itemtype="http://schema.org/Rating">' .
						'<meta itemprop="worstRating" content = "1">' .
						'<meta itemprop="bestRating" content = "' . $st_['max'] . '">' .
						'<meta itemprop="ratingValue" content = "' . $st_['total'] . '">' .
					'</span>';

				return $schema;

			}

	}



	/*-------------------------------------------
		4.16 - HEX to RGB
	-------------------------------------------*/

	function st_hex2rgb( $hex ) {

		if ( !$hex ) return;

		list( $r, $g, $b ) = sscanf( $hex, "%02x%02x%02x" );

		return "$r,$g,$b";

	}



	/*-------------------------------------------
		4.17 - st_wp_update_nav_menu_item
	-------------------------------------------*/
	/**
	 * Save the properties of a menu item or create a new one.
	 *
	 * The menu-item-title, menu-item-description, and menu-item-attr-title are expected
	 * to be pre-slashed since they are passed directly into `wp_insert_post()`.
	 *
	 * @since 3.0.0
	 *
	 * @param int   $menu_id         The ID of the menu. Required. If "0", makes the menu item a draft orphan.
	 * @param int   $menu_item_db_id The ID of the menu item. If "0", creates a new menu item.
	 * @param array $menu_item_data  The menu item's data.
	 * @return int|WP_Error The menu item's database ID or WP_Error object on failure.
	 */
	function st_wp_update_nav_menu_item( $menu_id = 0, $menu_item_db_id = 0, $menu_item_data = array() ) {
		$menu_id = (int) $menu_id;
		$menu_item_db_id = (int) $menu_item_db_id;

		// make sure that we don't convert non-nav_menu_item objects into nav_menu_item objects
		if ( ! empty( $menu_item_db_id ) && ! is_nav_menu_item( $menu_item_db_id ) )
			return new WP_Error( 'update_nav_menu_item_failed', __( 'The given object ID is not that of a menu item.' ) );

		$menu = wp_get_nav_menu_object( $menu_id );

		if ( ! $menu && 0 !== $menu_id ) {
			return new WP_Error( 'invalid_menu_id', __( 'Invalid menu ID.' ) );
		}

		if ( is_wp_error( $menu ) ) {
			return $menu;
		}

		$defaults = array(
			'menu-item-db-id' => $menu_item_db_id,
			'menu-item-object-id' => 0,
			'menu-item-object' => '',
			'menu-item-parent-id' => 0,
			'menu-item-position' => 0,
			'menu-item-type' => 'custom',
			'menu-item-title' => '',
			'menu-item-url' => '',
			'menu-item-description' => '',
			'menu-item-attr-title' => '',
			'menu-item-target' => '',
			'menu-item-classes' => '',
			'menu-item-xfn' => '',
			'menu-item-sidebar' => '',
			'menu-item-sidebar-columns' => '',
			'menu-item-status' => '',
		);

		$args = wp_parse_args( $menu_item_data, $defaults );

		if ( 0 == $menu_id ) {
			$args['menu-item-position'] = 1;
		} elseif ( 0 == (int) $args['menu-item-position'] ) {
			$menu_items = 0 == $menu_id ? array() : (array) wp_get_nav_menu_items( $menu_id, array( 'post_status' => 'publish,draft' ) );
			$last_item = array_pop( $menu_items );
			$args['menu-item-position'] = ( $last_item && isset( $last_item->menu_order ) ) ? 1 + $last_item->menu_order : count( $menu_items );
		}

		$original_parent = 0 < $menu_item_db_id ? get_post_field( 'post_parent', $menu_item_db_id ) : 0;

		if ( 'custom' != $args['menu-item-type'] ) {
			/* if non-custom menu item, then:
				* use original object's URL
				* blank default title to sync with original object's
			*/

			$args['menu-item-url'] = '';

			$original_title = '';
			if ( 'taxonomy' == $args['menu-item-type'] ) {
				$original_parent = get_term_field( 'parent', $args['menu-item-object-id'], $args['menu-item-object'], 'raw' );
				$original_title = get_term_field( 'name', $args['menu-item-object-id'], $args['menu-item-object'], 'raw' );
			} elseif ( 'post_type' == $args['menu-item-type'] ) {

				$original_object = get_post( $args['menu-item-object-id'] );
				$original_parent = (int) $original_object->post_parent;
				$original_title = $original_object->post_title;
			} elseif ( 'post_type_archive' == $args['menu-item-type'] ) {
				$original_object = get_post_type_object( $args['menu-item-object'] );
				if ( $original_object ) {
					$original_title = $original_object->labels->archives;
				}
			}

			if ( $args['menu-item-title'] == $original_title )
				$args['menu-item-title'] = '';

			// hack to get wp to create a post object when too many properties are empty
			if ( '' ==  $args['menu-item-title'] && '' == $args['menu-item-description'] )
				$args['menu-item-description'] = ' ';
		}

		// Populate the menu item object
		$post = array(
			'menu_order' => $args['menu-item-position'],
			'ping_status' => 0,
			'post_content' => $args['menu-item-description'],
			'post_excerpt' => $args['menu-item-attr-title'],
			'post_parent' => $original_parent,
			'post_title' => $args['menu-item-title'],
			'post_type' => 'nav_menu_item',
		);

		$update = 0 != $menu_item_db_id;

		// New menu item. Default is draft status
		if ( ! $update ) {
			$post['ID'] = 0;
			$post['post_status'] = 'publish' == $args['menu-item-status'] ? 'publish' : 'draft';
			$menu_item_db_id = wp_insert_post( $post );
			if ( ! $menu_item_db_id	|| is_wp_error( $menu_item_db_id ) )
				return $menu_item_db_id;

			/**
			 * Fires immediately after a new navigation menu item has been added.
			 *
			 * @since 4.4.0
			 *
			 * @see wp_update_nav_menu_item()
			 *
			 * @param int   $menu_id         ID of the updated menu.
			 * @param int   $menu_item_db_id ID of the new menu item.
			 * @param array $args            An array of arguments used to update/add the menu item.
			 */
			do_action( 'wp_add_nav_menu_item', $menu_id, $menu_item_db_id, $args );
		}

		// Associate the menu item with the menu term
		// Only set the menu term if it isn't set to avoid unnecessary wp_get_object_terms()
		 if ( $menu_id && ( ! $update || ! is_object_in_term( $menu_item_db_id, 'nav_menu', (int) $menu->term_id ) ) ) {
			wp_set_object_terms( $menu_item_db_id, array( $menu->term_id ), 'nav_menu' );
		}

		if ( 'custom' == $args['menu-item-type'] ) {
			$args['menu-item-object-id'] = $menu_item_db_id;
			$args['menu-item-object'] = 'custom';
		}

		$menu_item_db_id = (int) $menu_item_db_id;

		update_post_meta( $menu_item_db_id, '_menu_item_type', sanitize_key($args['menu-item-type']) );
		update_post_meta( $menu_item_db_id, '_menu_item_menu_item_parent', strval( (int) $args['menu-item-parent-id'] ) );
		update_post_meta( $menu_item_db_id, '_menu_item_object_id', strval( (int) $args['menu-item-object-id'] ) );
		update_post_meta( $menu_item_db_id, '_menu_item_object', sanitize_key($args['menu-item-object']) );
		update_post_meta( $menu_item_db_id, '_menu_item_target', sanitize_key($args['menu-item-target']) );
		update_post_meta( $menu_item_db_id, '_menu_item_sidebar', $args['menu-item-sidebar'] );
		update_post_meta( $menu_item_db_id, '_menu_item_sidebar_columns', $args['menu-item-sidebar-columns'] );

		$args['menu-item-classes'] = array_map( 'sanitize_html_class', explode( ' ', $args['menu-item-classes'] ) );
		$args['menu-item-xfn'] = implode( ' ', array_map( 'sanitize_html_class', explode( ' ', $args['menu-item-xfn'] ) ) );
		update_post_meta( $menu_item_db_id, '_menu_item_classes', $args['menu-item-classes'] );
		update_post_meta( $menu_item_db_id, '_menu_item_xfn', $args['menu-item-xfn'] );
		update_post_meta( $menu_item_db_id, '_menu_item_url', esc_url_raw($args['menu-item-url']) );

		if ( 0 == $menu_id )
			update_post_meta( $menu_item_db_id, '_menu_item_orphaned', (string) time() );
		elseif ( get_post_meta( $menu_item_db_id, '_menu_item_orphaned' ) )
			delete_post_meta( $menu_item_db_id, '_menu_item_orphaned' );

		// Update existing menu item. Default is publish status
		if ( $update ) {
			$post['ID'] = $menu_item_db_id;
			$post['post_status'] = 'draft' == $args['menu-item-status'] ? 'draft' : 'publish';
			wp_update_post( $post );
		}

		/**
		 * Fires after a navigation menu item has been updated.
		 *
		 * @since 3.0.0
		 *
		 * @see wp_update_nav_menu_item()
		 *
		 * @param int   $menu_id         ID of the updated menu.
		 * @param int   $menu_item_db_id ID of the updated menu item.
		 * @param array $args            An array of arguments used to update a menu item.
		 */
		do_action( 'wp_update_nav_menu_item', $menu_id, $menu_item_db_id, $args );

		return $menu_item_db_id;
	}



/*= 5 ===========================================

	W O O C O M M E R C E
	Custom things for WooCommerce

===============================================*/

function st_woocommerce() {

	if ( class_exists( 'WooCommerce' ) ) {

		global
			$st_Options,
			$st_Settings;


	/*-------------------------------------------
		5.1 - Add WooCommerce support
	-------------------------------------------*/

	add_theme_support( 'woocommerce' );


	/*-------------------------------------------
		5.2 - Remove WooCommerce prettyPhoto
	-------------------------------------------*/

	if (
		$st_Options['js']['prettyPhoto'] && empty( $st_Settings['prettyPhoto'] ) ||
		$st_Options['js']['prettyPhoto'] && !empty( $st_Settings['prettyPhoto'] ) && $st_Settings['prettyPhoto'] != 'no' ) {

		function st_remove_woo_lightbox() {
			remove_action( 'wp_head', array( $GLOBALS['woocommerce'], 'generator' ) );
			wp_dequeue_style( 'woocommerce_prettyPhoto_css' );
			wp_dequeue_script( 'prettyPhoto' );
			wp_dequeue_script( 'prettyPhoto-init' );
		}

		add_action( 'wp_enqueue_scripts', 'st_remove_woo_lightbox', 99 );

	}


	/*-------------------------------------------
		5.3 - Re-define number of products per row
	-------------------------------------------*/

	function st_loop_columns() {

		global
			$st_Options;

			return $st_Options['compatibility']['woocommerce']['per-row'];

	}

	add_filter( 'loop_shop_columns', 'st_loop_columns' );


	/*-------------------------------------------
		5.4 - Define image sizes
	-------------------------------------------*/

	function st_woocommerce_image_dimensions() {

		global
			$st_Options;

		$catalog = array(
			'width' 	=> $st_Options['compatibility']['woocommerce']['catalog'][0],
			'height'	=> $st_Options['compatibility']['woocommerce']['catalog'][1],
			'crop'		=> $st_Options['compatibility']['woocommerce']['catalog'][2],
		);

		$single = array(
			'width' 	=> $st_Options['compatibility']['woocommerce']['single'][0],
			'height'	=> $st_Options['compatibility']['woocommerce']['single'][1],
			'crop'		=> $st_Options['compatibility']['woocommerce']['single'][2],
		);

		$thumbnail = array(
			'width' 	=> $st_Options['compatibility']['woocommerce']['thumbnail'][0],
			'height'	=> $st_Options['compatibility']['woocommerce']['thumbnail'][1],
			'crop'		=> $st_Options['compatibility']['woocommerce']['thumbnail'][2],
		);

		// Image sizes
		update_option( 'shop_catalog_image_size', $catalog ); 		// Product category thumbs
		update_option( 'shop_single_image_size', $single ); 		// Single product image
		update_option( 'shop_thumbnail_image_size', $thumbnail ); 	// Image gallery thumbs

	}

	add_action( 'after_setup_theme', 'st_woocommerce_image_dimensions', 100 );
	add_action( 'after_switch_theme', 'st_woocommerce_image_dimensions', 100 );

	/*-------------------------------------------
		5.5 - Define number of products per page
	-------------------------------------------*/
    function products_per_page($cols)
    {
	    global $st_Settings, $st_Options;

        return ( !empty( $st_Settings['products_qty'] ) ? $st_Settings['products_qty'] : $st_Options['compatibility']['woocommerce']['qty'] );
    };

	add_filter( 'loop_shop_per_page', 'products_per_page', 20 );


	/*-------------------------------------------
		5.6 - Define number of related products
	-------------------------------------------*/

	function woo_related_products_limit() {

	  global
		$product,
		$st_Options;

		$args = array(
			'post_type'        		=> 'product',
			'posts_per_page'   		=> $st_Options['compatibility']['woocommerce']['related'],
			'ignore_sticky_posts' 	=> 1,
			'post__not_in'        	=> array( $product->get_id() )
		);

		$args['columns'] = 3;

		return $args;

	}

	add_filter( 'woocommerce_output_related_products_args', 'woo_related_products_limit' );


	/*-------------------------------------------
		5.7 - Register CSS
	-------------------------------------------*/

	if ( !is_admin() ) {

		function st_woocommerce_styles() {

			//if ( is_woocommerce() || is_cart() || is_checkout() || is_account_page() )
				wp_enqueue_style( 'st-woocommerce', get_template_directory_uri() . '/assets/css/woocommerce.css', false, null, 'all' );

		}

		add_action( 'wp_enqueue_scripts', 'st_woocommerce_styles', 30 );

	}


	/*-------------------------------------------
		5.8 - Remove JS & CSS from irrelevant pages
	-------------------------------------------*/

	function st_woocommerce_dequeue_assets() {

		if ( function_exists( 'is_woocommerce' ) ) {

			if ( !is_woocommerce() && !is_cart() && !is_checkout() && !is_account_page() ) {

				wp_dequeue_style( 'woocommerce-layout' );
				wp_dequeue_style( 'woocommerce-smallscreen' );
				wp_dequeue_style( 'woocommerce-general' );

				wp_dequeue_script( 'wc-add-to-cart' );
				wp_dequeue_script( 'jquery-blockui' );
				wp_dequeue_script( 'jquery-placeholder' );
				wp_dequeue_script( 'woocommerce' );
				wp_dequeue_script( 'jquery-cookie' );
				wp_dequeue_script( 'wc-cart-fragments' );

			}

		}

	}

	if ( !empty( $st_Settings['wooc_assets'] ) && $st_Settings['wooc_assets'] == 'yes' )
		add_action( 'wp_enqueue_scripts', 'st_woocommerce_dequeue_assets', 100 );


	} // if ( class_exists( 'WooCommerce' ) )

} // function st_woocommerce()


?>
